#!/bin/sh
#
# $Id: dhcp3-server.init.d,v 1.4 2003/07/13 19:12:41 mdz Exp $
#



# On what interfaces should the DHCP server (dhcpd) serve DHCP requests?
#       Separate multiple interfaces with spaces, e.g. "eth0 eth1".
#INTERFACES="br0"


# It is not safe to start if we don't have a default configuration...
#echo "/etc/init.d/dhcp-server not yet configured! - Aborting..."
#exit 1;
ENABLE=`/usr/sbin/sqldb_read /sys/network/udhcpd/enable`
IFACE=`/usr/sbin/sqldb_read	/sys/network/udhcpd/iface`
LEASEFILE=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/leasefile`	
PIDFILE=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/pidfile`
AUTOTIME=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/autotime`
DOMAIN=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/domain`
ROUTER=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/router`
STARTIP=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/startip`
STOPIP=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/stopip`
SUBNET=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/subnet`
DNS1=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/dns1`
DNS2=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/dns2`
DNS3=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/dns3`
LEASETIME=`/usr/sbin/sqldb_read	/sys/network/udhcpd/leasetime`


test -f /usr/sbin/dnsmasq || exit 0


case "$1" in
	start)
		rm -f /tmp/dnsmasq.conf
		echo "interface=$IFACE" > /tmp/dnsmasq.conf
		echo "domain=allnet.local" >> /tmp/dnsmasq.conf
		echo "bogus-priv" >> /tmp/dnsmasq.conf
		echo "domain-needed" >> /tmp/dnsmasq.conf
		echo "expand-hosts" >> /tmp/dnsmasq.conf
		echo "resolv-file=/etc/resolv.conf" >>/tmp/dnsmasq.conf
		if [ ${ENABLE} = "1" ] ; then
		echo "dhcp-authoritative" >> /tmp/dnsmasq.conf
		echo "dhcp-leasefile=$LEASEFILE" >> /tmp/dnsmasq.conf
		echo "dhcp-option=1,$SUBNET" >> /tmp/dnsmasq.conf
		echo "dhcp-option=3,$ROUTER" >> /tmp/dnsmasq.conf
		echo "dhcp-option=6,$ROUTER" >> /tmp/dnsmasq.conf
		echo "dhcp-option=28,192.168.5.255" >> /tmp/dnsmasq.conf
		echo "dhcp-range=$STARTIP,$STOPIP,$LEASETIME" >> /tmp/dnsmasq.conf		
		fi

		echo -n "Starting DNSMASQ server: "
		#start-stop-daemon -S -x `f`
		/usr/sbin/dnsmasq --conf-file=/tmp/dnsmasq.conf
		echo "."
		;;
	stop)
		echo -n "Stopping DNSMASQ server: dnsmasq"
		start-stop-daemon -K -x /usr/sbin/dnsmasq
		echo "."
		;;
	restart | force-reload)
		$0 stop
		sleep 2
		$0 start
		if [ "$?" != "0" ]; then
			exit 1
		fi
		;;
	*)
		echo "Usage: /etc/init.d/S80dnsmasq {start|stop|restart|force-reload}"
		exit 1 
esac

exit 0
