#!/bin/sh

NET_CONFIG="/etc/allnet/tcpip.xml"
WLAN_CONFIG="/etc/allnet/wlan.xml"
HOSTNAME=`/usr/bin/xml_edit $NET_CONFIG hostname 0`
WEBADMINPORT=`/usr/bin/xml_edit $NET_CONFIG webadminport 0`
IP=`/usr/bin/xml_edit $NET_CONFIG address 0`
NETMASK=`/usr/bin/xml_edit $NET_CONFIG netmask 0`
GW=`/usr/bin/xml_edit $NET_CONFIG gateway 0`
DNS1=`/usr/bin/xml_edit $NET_CONFIG dns1 0`
DNS2=`/usr/bin/xml_edit $NET_CONFIG dns2 0`
DHCPCLIENT=`/usr/bin/xml_edit $NET_CONFIG dhcpclient 0`

WLAN_MODE=`/usr/bin/xml_edit $WLAN_CONFIG wlan_mode 0`





case $1 in

 	start)
	echo "Running network....."


 	if [ ${WLAN_MODE} = "ap" ] ;then
 		insmod /root/rt3070ap.ko
 		ifconfig eth0 0.0.0.0 up
		ifconfig ra0 0.0.0.0 up
 		brctl addbr br0
		brctl addif br0 eth0
		brctl addif br0 ra0
		/bin/ip link set br0 up
	else
 		insmod /root/rt3070sta.ko
 		ifconfig eth0 0.0.0.0 up
		ifconfig ra0 0.0.0.0 up
 		brctl addbr br0
		brctl addif br0 eth0
		brctl addif br0 ra0
		/bin/ip link set br0 up
		iwpriv ra0 set NetworkType=Infra
		iwpriv ra0 set AuthMode=OPEN
		iwpriv ra0 set EncrypType=NONE
	        iwpriv ra0 set SSID=any 
	fi
	
   	if [ ${DHCPCLIENT} = "0" ] ; then
		
		killall udhcpc
		IP_addr=$IP
		mask=$NETMASK
		gw=$GATEWAY
		MAC=`/sbin/ifconfig    | grep 'eth0'    | tr -s ' '    | cut -d ' ' -f5 | cut -b 10-17` 
                HOSTNAMEMAC="${HOSTNAME}[${MAC}]"

		/sbin/ifconfig br0 ${IP} netmask ${NETMASK} > /dev/null 2>&1
		
		/etc/init.d/reconfigure_wlan &
				
		route delete default
		route add default gw ${GW}
		echo "$IP	$HOSTNAMEMAC" > /etc/hosts
		echo "127.0.0.1	localhost" >> /etc/hosts
 		/bin/hostname $HOSTNAMEMAC
  

	   # echo " *** Starting httpd ***>> "
	#	[ -z `pidof httpd` ] && /usr/sbin/httpd -p ${ADMIN_PORT}&
	    #/etc/init.d/watchdog.sh&  
		
	else
	   /sbin/ifconfig br0 0.0.0.0 up 
	   		
      	echo " *** DHCP client Start***>>"	
      #dhcpcd -h $HOSTNAME -l 604800&
      /sbin/udhcpc -i br0 
      	
      #	sleep 10
      #if [ -f /tmp/dhcpfail ] ; then
      #		rm -f /tmp/dhcpfail
      #		killall dhcpcd  	
      #		/etc/dhcpc/eth0.config
      #	fi
      	
      	
fi
	
      ;;
      
    stop)
    
		ifconfig br0 down
	 	brctl delif br0 eth0
 	 	brctl delif br0 ra0
 	        brctl delbr br0
 	        ifconfig ra0 down
 		rmmod rt3070sta
 		rmmod rt3070ap
	
       ;;
       
    restart)
        $0 stop
# sleep 7 seconds to wait smbd dead
        sleep 7        
        $0 start        
     ;;

    *)
      $0 restart
      ;;
esac
