#!/bin/sh
#
# $Id: dhcp3-server.init.d,v 1.4 2003/07/13 19:12:41 mdz Exp $
#



# On what interfaces should the DHCP server (dhcpd) serve DHCP requests?
#       Separate multiple interfaces with spaces, e.g. "eth0 eth1".
#INTERFACES="br0"


# It is not safe to start if we don't have a default configuration...
#echo "/etc/init.d/dhcp-server not yet configured! - Aborting..."
#exit 1;
ENABLE=`/usr/sbin/sqldb_read /sys/network/udhcpd/enable`
IFACE=`/usr/sbin/sqldb_read	/sys/network/udhcpd/iface`
LEASEFILE=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/leasefile`	
PIDFILE=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/pidfile`
AUTOTIME=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/autotime`
DOMAIN=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/domain`
ROUTER=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/router`
STARTIP=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/startip`
STOPIP=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/stopip`
SUBNET=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/subnet`
DNS1=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/dns1`
DNS2=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/dns2`
DNS3=`/usr/sbin/sqldb_read 	/sys/network/udhcpd/dns3`
LEASETIME=`/usr/sbin/sqldb_read	/sys/network/udhcpd/leasetime`



test -f /usr/sbin/udhcpd || exit 0


case "$1" in
	start)	if [ ${ENABLE} = "1" ] ; then
		rm -f /etc/udhcpd_br0.conf
		echo "start $STARTIP" > /etc/udhcpd_br0.conf
		echo "stop $STOPIP" >> /etc/udhcpd_br0.conf
		echo "interface $IFACE" >> /etc/udhcpd_br0.conf
		echo "lease_file $LEASEFILE" >> /etc/udhcpd_br0.conf
		echo "pidfile $PIDFILE" >> /etc/udhcpd_br0.conf
		echo "auto_time $AUTOTIME" >> /etc/udhcpd_br0.conf
		echo "opt lease $LEASETIME" >> /etc/udhcpd_br0.conf
		echo "opt subnet $SUBNET" >> /etc/udhcpd_br0.conf
		echo "opt domain $DOMAIN" >> /etc/udhcpd_br0.conf
		echo "opt router $ROUTER" >> /etc/udhcpd_br0.conf
		echo "opt dns $DNS1" >> /etc/udhcpd_br0.conf
		echo "opt dns $DNS2" >> /etc/udhcpd_br0.conf
		#echo "opt dns $DNS3" >> /etc/udhcpd_br0.conf
		
		echo -n "Starting UDHCPD server: "
		start-stop-daemon -S -x udhcpd /etc/udhcpd_br0.conf
		echo "."
		else
		echo "UDHCPD is disabled!"
		fi
		;;
	stop)
		echo -n "Stopping UDHCPD server: udhcpd"
		#start-stop-daemon -K -x /usr/sbin/udhcpd
		killall udhcpd
		echo "."
		;;
	restart | force-reload)
		$0 stop
		sleep 2
		$0 start
		if [ "$?" != "0" ]; then
			exit 1
		fi
		;;
	*)
		echo "Usage: /etc/init.d/S80udhcpd {start|stop|restart|force-reload}"
		exit 1 
esac

exit 0
