<?php
include "../include/sqldb.php";
$error=false;
$syntax=null;
if(!isset($_GET['qt']) || !isset($_GET['p'])) { 
	$error = true;
	$syntax = "<pre style=\"font-size: 16px;font-weight: bold\">*** missing parameter ***</pre><br />";
} else {
	$period=$_GET['p'];
	$querytype=$_GET['qt'];
	if($period=="" || $querytype=="") {
		$error=true;
		$syntax = "<pre style=\"font-size: 16px;font-weight: bold\">*** missing parameter values ***</pre><br />";;
	} else {
		if(!in_array($period, range(0,5)) || !in_array($querytype, range(0,4))) {
			$error=true;
			$syntax = "<pre style=\"font-size: 16px; font-weight: bold\">*** error: parameter out of range  ***</pre><br />";
		}
	}
}
if($error) {
	echo $syntax;
	echo "<pre style=\"font-size: 16px;\"><p>SQLite DB xml output</p>";
	echo "<p>http://".db_read("/sys/network/lan/ipaddress")."/xml?qt=*&p=*</p>";
	echo "<p>option <span style=\"font-weight:bold;\">qt</span> (query type)<br />-------------------------<br />";
	echo "<span style=\"font-weight:bold;\">0</span> = Sum consumtation (kw)<br />";
	echo "<span style=\"font-weight:bold;\">1</span> = List only min values<br />";
	echo "<span style=\"font-weight:bold;\">2</span> = List only max values<br />";
	echo "<span style=\"font-weight:bold;\">3</span> = List all Values<br />";
	echo "<span style=\"font-weight:bold;\">4</span> = Average</p>";
	echo "<p>option <span style=\"font-weight:bold;\">p</span> (period)<br />-------------------------<br />";
	echo "<span style=\"font-weight:bold;\">0</span> = today<br />";
	echo "<span style=\"font-weight:bold;\">1</span> = yesterday<br />";
	echo "<span style=\"font-weight:bold;\">2</span> = week<br />";
	echo "<span style=\"font-weight:bold;\">3</span> = last week<br />";
	echo "<span style=\"font-weight:bold;\">4</span> = month<br />";
	echo "<span style=\"font-weight:bold;\">5</span> = last month</p></pre>";
	exit;
}
date_default_timezone_set(db_read("/sys/network/ntpd/timezone"));
$voltage0 = db_read("/powermeter/voltage0");
$voltage1 = db_read("/powermeter/voltage1");
$voltage2 = db_read("/powermeter/voltage2");
$splitrate = db_read("/powermeter/config/config_splitrate");
$energycosteuro0 = db_read("/powermeter/config/energycosteuro0");
$energycosteuro1 = db_read("/powermeter/config/energycosteuro1");
$energycost_valid_from0 = db_read("/powermeter/config/energycost_valid_from0");
$energycost_valid_from1 = db_read("/powermeter/config/energycost_valid_from1");
$dbpath = db_read ("/powermeter/config/dbpath");
$dbname = db_read ("/powermeter/config/dbname");
$database = "sqlite:". $dbpath."/".$dbname;
$return="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
$return="<all3691>\n<query>\n";
switch ($period) {
	case "0":
		$return.="<period>today</period>\n";
		break;
	case "1":
		$return.="<period>yesterday</period>\n";
		break;	
	case "2":
		$return.="<period>week</period>\n";
		break;
	case "3":
		$return.="<period>last week</period>\n";
		break;
	case "4":
		$return.="<period>month</period>\n";
		break;
	case "5":
		$return.="<period>last month</period>\n";
		break;		
}
switch ($querytype) {
	case "0":
		$return.="<querytype>sum</querytype>\n";
		break;
	case "1":
		$return.="<querytype>min</querytype>\n";
		break;
	case "2":
		$return.="<querytype>max</querytype>\n";
		break;
	case "3":
		$return.="<querytype>all</querytype>\n";
		break;
	case "4":
		$return.="<querytype>average</querytype>\n";
		break;		
}
$return.= "</query>\n";
$db= new PDO($database, '', '');
$now=strtotime(date("Y-m-d H:i:s"));
$day=86400;
$week=604800;
$tomidnight=$day-(date("H",$now)*3600)+(date("i",$now)*60);
$frommidnight=(date("H",$now)*3600)+(date("i",$now)*60);
$from=" FROM measurements WHERE substr(datetime(timestamp,'localtime'),1,10) ";
switch ($p) {
	case 0: # Heute
		$where = $select . " = '".date("Y-m-d",$now)."'";
		break;
	case 1: # Gestern
		$where = $select . " = '".date("Y-m-d",$now-$day)."'";
		break;
	case 2: # Aktuelle Woche
		$beg_weeknow=(date("w")*$day)-$day;
		$where = $select . " BETWEEN '".date("Y-m-",$now-$beg_weeknow).date("d",$now-$beg_weeknow)."' AND '".date("Y-m-d")."'";
		break;		
	case 3: # Letzte Woche
		$weekday=(date("w")); #+1
		$end_lastweek=($day*$weekday);
		$beg_lastweek=($week-$day);
		$now=$now-$end_lastweek; 	
		$where = $select . " BETWEEN '".date("Y-m-d",$now-$beg_lastweek)."' AND '".date("Y-m-d",$now)."'";
		break;				
	case 4: # Aktueller Monat
		$from=" FROM measurements WHERE substr(datetime(timestamp,'localtime'),1,7) ";
		$where = $select . " = '".date("Y-m")."'";
		break;						
	case 5: # Letzter Monat
		$from=" FROM measurements WHERE substr(datetime(timestamp,'localtime'),1,7) ";
		$day=(date("j")*$day);
		$lastmonth=$now-$day;
		$where = $select . " = '".date("Y-m",$lastmonth)."'";
		break;						
	case 6: # Aktuelles Jahr
		$where = $select . " = '".date("Y")."'";
		break;				
	case 999:
		$where = $select . " '2010-10-26' AND substr(timestamp,12,2) ='06' AND substr(timestamp,15,2) ='06'";
		break;
}

switch ($querytype) { // Art der Abfrage Summe Min Max Alles
	case 0: // Nur Summe
		switch($p) { // Tag Gestern Woche Letzte Woche etc.
			case 2: // Woche
				for($i=($now-$beg_weeknow);$i<=$now;$i+=$day) {
					$where =  " = '".date("Y-m-",$i).date("d",$i)."'";
					$select = "SELECT datetime(timestamp,'localtime') as timestamp, sum(w0) as w0, sum(w1) as w1, sum(w2) as w2, sum(w3) as w3, sum(w4) as w4, sum(w5) as w5, duration ".$from;
					$dbquery = $select . $where;
					$result = $db->query($dbquery);
					foreach($result as $r) {
						$row_sum0=(((($r['w0']/1000)*$r['duration'])/3600)+((($r['w1']/1000)*$r['duration'])/3600)+((($r['w2']/1000)*$r['duration'])/3600));
						$row_sum1=(((($r['w3']/1000)*$r['duration'])/3600)+((($r['w4']/1000)*$r['duration'])/3600)+((($r['w5']/1000)*$r['duration'])/3600));
						$return.="<row>\n";
						$return.="<time>".substr($r['timestamp'],0,10)."</time>";
						$return.="<kw0>".round((($r['w0']/1000)*$r['duration'])/3600,2)."</kw0>\n";
						$return.="<kw1>".round((($r['w1']/1000)*$r['duration'])/3600,2)."</kw1>\n";
						$return.="<kw2>".round((($r['w2']/1000)*$r['duration'])/3600,2)."</kw2>\n";
						$return.="<kw3>".round((($r['w3']/1000)*$r['duration'])/3600,2)."</kw3>\n";
						$return.="<kw4>".round((($r['w4']/1000)*$r['duration'])/3600,2)."</kw4>\n";
						$return.="<kw5>".round((($r['w5']/1000)*$r['duration'])/3600,2)."</kw5>\n";
						$return.="<consumptionkw0>".round($row_sum0,2)."</consumptionkw0>\n";
						$return.="<consumptionkw1>".round($row_sum1,2)."</consumptionkw1>\n";
						$return.="</row>\n";
						$total0+=$row_sum0;
						$total1+=$row_sum1;
					}
				}
				$return.="<weektotal>";
				$return.="<consumptionkw0>".round($total0,2)."</consumptionkw0>\n";
				$return.="<consumptionkw1>".round($total1,2)."</consumptionkw1>\n";
				$return.="</weektotal>";
				$return.="</all3691>\n";
				header("Content-Type: text/xml charset:utf8");				
				echo $return;
				exit;
			case 3: // letzte Woche		
				$weekday=(date("w")+1);
				$end_lastweek=$now; #-(86400*$weekday);			
				$beg_lastweek=($end_lastweek-$week+86400);	
				$now=$now-$end_lastweek;			
				for($i=$beg_lastweek;$i<=$end_lastweek;$i+=$day) {
					$where = " = '".date("Y-m-d",$i)."'";
					$select = "SELECT datetime(timestamp,'localtime') as timestamp, sum(w0) as w0, sum(w1) as w1, sum(w2) as w2, sum(w3) as w3, sum(w4) as w4, sum(w5) as w5, duration ".$from;
					$dbquery = $select . $where;
					$result = $db->query($dbquery);				
					foreach($result as $r) {
						$row_sum0=(((($r['w0']/1000)*$r['duration'])/3600)+((($r['w1']/1000)*$r['duration'])/3600)+((($r['w2']/1000)*$r['duration'])/3600));
						$row_sum1=(((($r['w3']/1000)*$r['duration'])/3600)+((($r['w4']/1000)*$r['duration'])/3600)+((($r['w5']/1000)*$r['duration'])/3600));
						$return.="<row>\n";
						$return.="<time>".substr($r['timestamp'],0,10)."</time>";
						$return.="<kw0>".round((($r['w0']/1000)*$r['duration'])/3600,2)."</kw0>\n";
						$return.="<kw1>".round((($r['w1']/1000)*$r['duration'])/3600,2)."</kw1>\n";
						$return.="<kw2>".round((($r['w2']/1000)*$r['duration'])/3600,2)."</kw2>\n";
						$return.="<kw3>".round((($r['w3']/1000)*$r['duration'])/3600,2)."</kw3>\n";
						$return.="<kw4>".round((($r['w4']/1000)*$r['duration'])/3600,2)."</kw4>\n";
						$return.="<kw5>".round((($r['w5']/1000)*$r['duration'])/3600,2)."</kw5>\n";
						$return.="<consumptionkw0>".round($row_sum0,2)."</consumptionkw0>\n";
						$return.="<consumptionkw1>".round($row_sum1,2)."</consumptionkw1>\n";
						$return.="</row>\n";
						$total0+=$row_sum0;
						$total1+=$row_sum1;			
					}
				}
				$return.="<lastweektotal>";
				$return.="<consumptionkw0>".round($total0,2)."</consumptionkw0>\n";
				$return.="<consumptionkw1>".round($total1,2)."</consumptionkw1>\n";
				$return.="</lastweektotal>";
				$return.="</all3691>\n";
				header("Content-Type: text/xml charset:utf8");				
				echo $return;
				exit;
			case 4:	// Monat	
				$start=$now-(date("d",$now)*$day)+$tomidnight;
				for($i=$start;$i<=$now;$i+=$day) {	
					$from=" FROM measurements WHERE substr(datetime(timestamp,'localtime'),1,10) ";				
					$where = " = '".date("Y-m-d",$i)."'";
					$select = "SELECT datetime(timestamp,'localtime') as timestamp, sum(w0) as w0, sum(w1) as w1, sum(w2) as w2, sum(w3) as w3, sum(w4) as w4, sum(w5) as w5, duration ".$from;
					$dbquery = $select . $where;
					$result = $db->query($dbquery);				
					foreach($result as $r) {
						$row_sum0=(((($r['w0']/1000)*$r['duration'])/3600)+((($r['w1']/1000)*$r['duration'])/3600)+((($r['w2']/1000)*$r['duration'])/3600));
						$row_sum1=(((($r['w3']/1000)*$r['duration'])/3600)+((($r['w4']/1000)*$r['duration'])/3600)+((($r['w5']/1000)*$r['duration'])/3600));
						$return.="<row>\n";
						$return.="<time>".substr($r['timestamp'],0,10)."</time>";
						$return.="<kw0>".round((($r['w0']/1000)*$r['duration'])/3600,2)."</kw0>\n";
						$return.="<kw1>".round((($r['w1']/1000)*$r['duration'])/3600,2)."</kw1>\n";
						$return.="<kw2>".round((($r['w2']/1000)*$r['duration'])/3600,2)."</kw2>\n";
						$return.="<kw3>".round((($r['w3']/1000)*$r['duration'])/3600,2)."</kw3>\n";
						$return.="<kw4>".round((($r['w4']/1000)*$r['duration'])/3600,2)."</kw4>\n";
						$return.="<kw5>".round((($r['w5']/1000)*$r['duration'])/3600,2)."</kw5>\n";
						$return.="<consumptionkw0>".round($row_sum0,2)."</consumptionkw0>\n";
						$return.="<consumptionkw1>".round($row_sum1,2)."</consumptionkw1>\n";
						$return.="</row>\n";
						$total0+=$row_sum0;
						$total1+=$row_sum1;
					}
				}
				$return.="<monthtotal>";
				$return.="<consumptionkw0>".round($total0,2)."</consumptionkw0>\n";
				$return.="<consumptionkw1>".round($total1,2)."</consumptionkw1>\n";
				$return.="</monthtotal>";
				$return.="</all3691>\n";
				header("Content-Type: text/xml charset:utf8");					
				echo $return;
				exit;
			case 5: // Letzter Monat
				$day=((date("j",$now))*86400);
				$lastmonth=$now-$day;
				$start=$lastmonth-(date("j",$lastmonth)*86400)+$tomidnight;
				for($i=$start;$i<=$lastmonth;$i+=86400) {		
					$from=" FROM measurements WHERE substr(datetime(timestamp,'localtime'),1,10) ";
					$where = " = '".date("Y-m-d",$i)."'";
					$select = "SELECT datetime(timestamp,'localtime') as timestamp, sum(w0) as w0, sum(w1) as w1, sum(w2) as w2, sum(w3) as w3, sum(w4) as w4, sum(w5) as w5, duration ".$from;
					$dbquery = $select . $where;
					$result = $db->query($dbquery);		
					foreach($result as $r) {
						$row_sum0=(((($r['w0']/1000)*$r['duration'])/3600)+((($r['w1']/1000)*$r['duration'])/3600)+((($r['w2']/1000)*$r['duration'])/3600));
						$row_sum1=(((($r['w3']/1000)*$r['duration'])/3600)+((($r['w4']/1000)*$r['duration'])/3600)+((($r['w5']/1000)*$r['duration'])/3600));
						$return.="<row>\n";
						$return.="<time>".substr($r['timestamp'],0,10)."</time>";
						$return.="<kw0>".round((($r['w0']/1000)*$r['duration'])/3600,2)."</kw0>\n";
						$return.="<kw1>".round((($r['w1']/1000)*$r['duration'])/3600,2)."</kw1>\n";
						$return.="<kw2>".round((($r['w2']/1000)*$r['duration'])/3600,2)."</kw2>\n";
						$return.="<kw3>".round((($r['w3']/1000)*$r['duration'])/3600,2)."</kw3>\n";
						$return.="<kw4>".round((($r['w4']/1000)*$r['duration'])/3600,2)."</kw4>\n";
						$return.="<kw5>".round((($r['w5']/1000)*$r['duration'])/3600,2)."</kw5>\n";
						$return.="<consumptionkw0>".round($row_sum0,2)."</consumptionkw0>\n";
						$return.="<consumptionkw1>".round($row_sum1,2)."</consumptionkw1>\n";
						$return.="</row>\n";
						$total0+=$row_sum0;
						$total1+=$row_sum1;
					}
				}
				$return.="<lastmonthtotal>";
				$return.="<consumptionkw0>".round($total0,2)."</consumptionkw0>\n";
				$return.="<consumptionkw1>".round($total1,2)."</consumptionkw1>\n";
				$return.="</lastmonthtotal>";
				$return.="</all3691>\n";
				header("Content-Type: text/xml charset:utf8");				
				echo $return;
				exit;			
			default:  // Heute, Gestern
				$select = "SELECT datetime(timestamp,'localtime') as timestamp, sum(w0) as w0, sum(w1) as w1, sum(w2) as w2, sum(w3) as w3, sum(w4) as w4, sum(w5) as w5, duration ".$from;
				$result = $db->query($dbquery);
			break;
		}	
		break;
	case 1: // Nur Minimum Werte
		switch($p) { // Tag Gestern Woche Letzte Woche etc.
			case 2: // Woche
				for($i=($now-$beg_weeknow);$i<=$now;$i+=$day) {
					$where =  " = '".date("Y-m-",$i).date("d",$i)."'";
					$select = "SELECT datetime(timestamp,'localtime') as timestamp, min(w0) as w0, min(w1) as w1, min(w2) as w2, min(w3) as w3, min(w4) as w4, min(w5) as w5, duration ".$from;
					$dbquery = $select . $where;
					$result = $db->query($dbquery);
					foreach($result as $r) {
						$row_sum0=($r['w0']+$r['w1']+$r['w2']);
						$row_sum1=($r['w3']+$r['w4']+$r['w5']);
						$return.="<row>\n";
						$return.="<time>".substr($r['timestamp'],0,10)."</time>";
						$return.="<w0>".intval($r['w0'])."</w0>\n";
						$return.="<w1>".intval($r['w1'])."</w1>\n";
						$return.="<w2>".intval($r['w2'])."</w2>\n";
						$return.="<w3>".intval($r['w3'])."</w3>\n";
						$return.="<w4>".intval($r['w4'])."</w4>\n";
						$return.="<w5>".intval($r['w5'])."</w5>\n";
						$return.="<rowsumw0>".intval($row_sum0)."</rowsumw0>\n";
						$return.="<rowsumw1>".intval($row_sum1)."</rowsumw1>\n";
						$return.="</row>\n";												
					}
				}			
				$return.="</all3691>\n";
				header("Content-Type: text/xml charset:utf8");						
				echo $return;
				exit;
			case 3: // Letzte Woche
				$weekday=(date("w")+1);
				$end_lastweek=$now; #-(86400*$weekday);			
				$beg_lastweek=($end_lastweek-$week+86400);	
				for($i=$beg_lastweek;$i<=$end_lastweek;$i+=$day) {
					$where = " = '".date("Y-m-d",$i)."'";
					$select = "SELECT datetime(timestamp,'localtime') as timestamp, min(w0) as w0, min(w1) as w1, min(w2) as w2, min(w3) as w3, min(w4) as w4, min(w5) as w5, duration ".$from;
					$dbquery = $select . $where;
					$result = $db->query($dbquery);				
					foreach($result as $r) {
						$row_sum0=($r['w0']+$r['w1']+$r['w2']);
						$row_sum1=($r['w3']+$r['w4']+$r['w5']);
						$return.="<row>\n";
						$return.="<time>".substr($r['timestamp'],0,10)."</time>";
						$return.="<w0>".intval($r['w0'])."</w0>\n";
						$return.="<w1>".intval($r['w1'])."</w1>\n";
						$return.="<w2>".intval($r['w2'])."</w2>\n";
						$return.="<w3>".intval($r['w3'])."</w3>\n";
						$return.="<w4>".intval($r['w4'])."</w4>\n";
						$return.="<w5>".intval($r['w5'])."</w5>\n";
						$return.="<rowsumw0>".intval($row_sum0)."</rowsumw0>\n";
						$return.="<rowsumw1>".intval($row_sum1)."</rowsumw1>\n";
						$return.="</row>\n";			
					}
				}
				$return.="</all3691>\n";
				header("Content-Type: text/xml charset:utf8");
				echo $return;
				exit;
			case 4:	// Monat	
				$start=$now-(date("d",$now)*$day)+$tomidnight;
				for($i=$start;$i<=$now;$i+=$day) {
					$from=" FROM measurements WHERE substr(datetime(timestamp,'localtime'),1,10) ";
					$where = " = '".date("Y-m-d",$i)."'";
					$select = "SELECT datetime(timestamp,'localtime') as timestamp, min(w0) as w0, min(w1) as w1, min(w2) as w2, min(w3) as w3, min(w4) as w4, min(w5) as w5, duration ".$from;
					$dbquery = $select . $where;
					$result = $db->query($dbquery);				
					foreach($result as $r) {
						$row_sum0=($r['w0']+$r['w1']+$r['w2']);
						$row_sum1=($r['w3']+$r['w4']+$r['w5']);
						$return.="<row>\n";
						$return.="<time>".substr($r['timestamp'],0,10)."</time>";
						$return.="<w0>".intval($r['w0'])."</w0>\n";
						$return.="<w1>".intval($r['w1'])."</w1>\n";
						$return.="<w2>".intval($r['w2'])."</w2>\n";
						$return.="<w3>".intval($r['w3'])."</w3>\n";
						$return.="<w4>".intval($r['w4'])."</w4>\n";
						$return.="<w5>".intval($r['w5'])."</w5>\n";
						$return.="<rowsumw0>".intval($row_sum0)."</rowsumw0>\n";
						$return.="<rowsumw1>".intval($row_sum1)."</rowsumw1>\n";
						$return.="</row>\n";
					}
				}
				$return.="</all3691>\n";
				header("Content-Type: text/xml charset:utf8");
				echo $return;
				exit;
			case 5: // Letzter Monat
				$day=((date("j",$now))*86400);
				$lastmonth=$now-$day;
				$start=$lastmonth-(date("j",$lastmonth)*86400)+$tomidnight;
				for($i=$start;$i<=$lastmonth;$i+=86400) {
					$from=" FROM measurements WHERE substr(datetime(timestamp,'localtime'),1,10) ";
					$where = " = '".date("Y-m-d",$i)."'";
					$select = "SELECT datetime(timestamp,'localtime') as timestamp, min(w0) as w0, min(w1) as w1, min(w2) as w2, min(w3) as w3, min(w4) as w4, min(w5) as w5, duration ".$from;
					$dbquery = $select . $where;
					$result = $db->query($dbquery);		
					foreach($result as $r) {
						if($r['timestamp']) {
							$row_sum0=($r['w0']+$r['w1']+$r['w2']);
							$row_sum1=($r['w3']+$r['w4']+$r['w5']);
							$return.="<row>\n";
							$return.="<time>".substr($r['timestamp'],0,10)."</time>";
							$return.="<w0>".intval($r['w0'])."</w0>\n";
							$return.="<w1>".intval($r['w1'])."</w1>\n";
							$return.="<w2>".intval($r['w2'])."</w2>\n";
							$return.="<w3>".intval($r['w3'])."</w3>\n";
							$return.="<w4>".intval($r['w4'])."</w4>\n";
							$return.="<w5>".intval($r['w5'])."</w5>\n";
							$return.="<rowsumw0>".intval($row_sum0)."</rowsumw0>\n";
							$return.="<rowsumw1>".intval($row_sum1)."</rowsumw1>\n";
							$return.="</row>\n";
						}
					}
				}
				$return.="</all3691>\n";
				header("Content-Type: text/xml charset:utf8");				
				echo $return;
				exit;			
			default: // Heute, Gestern
				$select = "SELECT datetime(timestamp,'localtime') as timestamp, min(w0) as w0, min(w1) as w1, min(w2) as w2, min(w3) as w3, min(w4) as w4, min(w5) as w5, duration ".$from;
				$result = $db->query($dbquery);
			break;
		}	
		break;
	case 2: // Nur Maximum Werte
		switch($p) { // Tag Gestern Woche Letzte Woche etc.
			case 2: // Woche 
				for($i=($now-$beg_weeknow);$i<=$now;$i+=$day) {
					$where =  " = '".date("Y-m-",$i).date("d",$i)."'";
					$select = "SELECT datetime(timestamp,'localtime') as timestamp, max(w0) as w0, max(w1) as w1, max(w2) as w2, max(w3) as w3, max(w4) as w4, max(w5) as w5, duration ".$from;
					$dbquery = $select . $where;
					$result = $db->query($dbquery);
					foreach($result as $r) {
						$row_sum0=($r['w0']+$r['w1']+$r['w2']);
						$row_sum1=($r['w3']+$r['w4']+$r['w5']);
						$return.="<row>\n";
						$return.="<time>".substr($r['timestamp'],0,10)."</time>";
						$return.="<w0>".intval($r['w0'])."</w0>\n";
						$return.="<w1>".intval($r['w1'])."</w1>\n";
						$return.="<w2>".intval($r['w2'])."</w2>\n";
						$return.="<w3>".intval($r['w3'])."</w3>\n";
						$return.="<w4>".intval($r['w4'])."</w4>\n";
						$return.="<w5>".intval($r['w5'])."</w5>\n";
						$return.="<rowsumw0>".intval($row_sum0)."</rowsumw0>\n";
						$return.="<rowsumw1>".intval($row_sum1)."</rowsumw1>\n";
						$return.="</row>\n";
					}
				}	
				$return.="</all3691>\n";
				header("Content-Type: text/xml charset:utf8");					
				echo $return;
				exit;
			case 3: // letzte Woche 	
				$weekday=(date("w")+1);
				$end_lastweek=$now; #-(86400*$weekday);			
				$beg_lastweek=($end_lastweek-$week+86400);			
				for($i=$beg_lastweek;$i<=$end_lastweek;$i+=$day) {
					$where = " = '".date("Y-m-d",$i)."'";
					$select = "SELECT datetime(timestamp,'localtime') as timestamp, max(w0) as w0, max(w1) as w1, max(w2) as w2, max(w3) as w3, max(w4) as w4, max(w5) as w5, duration ".$from;
					$dbquery = $select . $where;
					$result = $db->query($dbquery);				
					foreach($result as $r) {
						$row_sum0=($r['w0']+$r['w1']+$r['w2']);
						$row_sum1=($r['w3']+$r['w4']+$r['w5']);
						$return.="<row>\n";
						$return.="<time>".substr($r['timestamp'],0,10)."</time>";
						$return.="<w0>".intval($r['w0'])."</w0>\n";
						$return.="<w1>".intval($r['w1'])."</w1>\n";
						$return.="<w2>".intval($r['w2'])."</w2>\n";
						$return.="<w3>".intval($r['w3'])."</w3>\n";
						$return.="<w4>".intval($r['w4'])."</w4>\n";
						$return.="<w5>".intval($r['w5'])."</w5>\n";
						$return.="<rowsumw0>".intval($row_sum0)."</rowsumw0>\n";
						$return.="<rowsumw1>".intval($row_sum1)."</rowsumw1>\n";
						$return.="</row>\n";														
					}
				}
				$return.="</all3691>\n";
				header("Content-Type: text/xml charset:utf8");				
				echo $return;
				exit;
			case 4:	// Monat	
				$start=$now-(date("d",$now)*$day)+$tomidnight;
				for($i=$start;$i<=$now;$i+=86400) {
					$from=" FROM measurements WHERE substr(datetime(timestamp,'localtime'),1,10) ";
					$where = " = '".date("Y-m-d",$i)."'";
					$select = "SELECT datetime(timestamp,'localtime') as timestamp, max(w0) as w0, max(w1) as w1, max(w2) as w2, max(w3) as w3, max(w4) as w4, max(w5) as w5, duration ".$from;
					$dbquery = $select . $where;
					$result = $db->query($dbquery);				
					foreach($result as $r) {
						$row_sum0=($r['w0']+$r['w1']+$r['w2']);
						$row_sum1=($r['w3']+$r['w4']+$r['w5']);
						$return.="<row>\n";
						$return.="<time>".substr($r['timestamp'],0,10)."</time>";
						$return.="<w0>".intval($r['w0'])."</w0>\n";
						$return.="<w1>".intval($r['w1'])."</w1>\n";
						$return.="<w2>".intval($r['w2'])."</w2>\n";
						$return.="<w3>".intval($r['w3'])."</w3>\n";
						$return.="<w4>".intval($r['w4'])."</w4>\n";
						$return.="<w5>".intval($r['w5'])."</w5>\n";
						$return.="<rowsumw0>".intval($row_sum0)."</rowsumw0>\n";
						$return.="<rowsumw1>".intval($row_sum1)."</rowsumw1>\n";
						$return.="</row>\n";													
					}
				}
				$return.="</all3691>\n";
				header("Content-Type: text/xml charset:utf8");				
				echo $return;
				exit;
			case 5: // Letzter Monat		  					
				$day=((date("j",$now))*86400);
				$lastmonth=$now-$day;
				$start=$lastmonth-(date("j",$lastmonth)*86400)+$tomidnight;
				for($i=$start;$i<=$lastmonth;$i+=86400) {
					$from=" FROM measurements WHERE substr(datetime(timestamp,'localtime'),1,10) ";
					$where = " = '".date("Y-m-d",$i)."'";
					$select = "SELECT datetime(timestamp,'localtime') as timestamp, max(w0) as w0, max(w1) as w1, max(w2) as w2, max(w3) as w3, max(w4) as w4, max(w5) as w5, duration ".$from;
					$dbquery = $select . $where;
					$result = $db->query($dbquery);		
					foreach($result as $r) {
						if($r['timestamp']) {
							$row_sum0=($r['w0']+$r['w1']+$r['w2']);
							$row_sum1=($r['w3']+$r['w4']+$r['w5']);
							$return.="<row>\n";
							$return.="<time>".substr($r['timestamp'],0,10)."</time>";
							$return.="<w0>".intval($r['w0'])."</w0>\n";
							$return.="<w1>".intval($r['w1'])."</w1>\n";
							$return.="<w2>".intval($r['w2'])."</w2>\n";
							$return.="<w3>".intval($r['w3'])."</w3>\n";
							$return.="<w4>".intval($r['w4'])."</w4>\n";
							$return.="<w5>".intval($r['w5'])."</w5>\n";
							$return.="<rowsumw0>".intval($row_sum0)."</rowsumw0>\n";
							$return.="<rowsumw1>".intval($row_sum1)."</rowsumw1>\n";
							$return.="</row>\n";	
						}
					}
				}
				$return.="</all3691>\n";
				header("Content-Type: text/xml charset:utf8");
				echo $return;
				exit;			
			default: // Heute, Gestern
				$select = "SELECT datetime(timestamp,'localtime') as timestamp, max(w0) as w0, max(w1) as w1, max(w2) as w2, max(w3) as w3, max(w4) as w4, max(w5) as w5, duration ".$from;
				$result = $db->query($dbquery);
			break;
		}	
		break;
	case 3: // Alle Werte
		$select = "SELECT datetime(timestamp,'localtime') as timestamp, w0, w1, w2, w3, w4, w5 ".$from;
		break;
	case 4: // Durchschnitt
		switch($p) { // Tag Gestern Woche Letzte Woche etc.
			case 2: // Woche 
				$count=0;
				for($i=($now-$beg_weeknow);$i<=$now;$i+=$day) {
					$where =  " = '".date("Y-m-",$i).date("d",$i)."'";
					$select = "SELECT datetime(timestamp,'localtime') as timestamp, avg(w0) as w0, avg(w1) as w1 ,avg(w2) as w2, avg(w3) as w3, avg(w4) as w4, avg(w5) as w5, duration ".$from;
					$dbquery = $select . $where;
					$result = $db->query($dbquery);
					foreach($result as $r) {
						$row_sum0=($r['w0']+$r['w1']+$r['w2']);
						$row_sum1=($r['w3']+$r['w4']+$r['w5']);
						$return.="<row>\n";
						$return.="<time>".substr($r['timestamp'],0,10)."</time>";
						$return.="<w0>".intval($r['w0'])."</w0>\n";
						$return.="<w1>".intval($r['w1'])."</w1>\n";
						$return.="<w2>".intval($r['w2'])."</w2>\n";
						$return.="<w3>".intval($r['w3'])."</w3>\n";
						$return.="<w4>".intval($r['w4'])."</w4>\n";
						$return.="<w5>".intval($r['w5'])."</w5>\n";
						$return.="<rowsumw0>".intval($row_sum0)."</rowsumw0>\n";
						$return.="<rowsumw1>".intval($row_sum1)."</rowsumw1>\n";
						$return.="</row>\n";
					}
					$count++;
				}	
				$return.="</all3691>\n";
				header("Content-Type: text/xml charset:utf8");					
				echo $return;
				exit;
			case 3: // letzte Woche 	
				$weekday=(date("w")+1);
				$end_lastweek=$now; #-(86400*$weekday);			
				$beg_lastweek=($end_lastweek-$week+86400);
				$count=0;
				for($i=$beg_lastweek;$i<=$end_lastweek;$i+=$day) {
					$where = " = '".date("Y-m-d",$i)."'";
					$select = "SELECT datetime(timestamp,'localtime') as timestamp, avg(w0) as w0, avg(w1) as w1 ,avg(w2) as w2, avg(w3) as w3, avg(w4) as w4, avg(w5) as w5, duration ".$from;
					$dbquery = $select . $where;
					$result = $db->query($dbquery);				
					foreach($result as $r) {
						$row_sum0=(floatval($r['w0'])+floatval($r['w1'])+floatval($r['w2']));
						$row_sum1=(floatval($r['w3'])+floatval($r['w4'])+floatval($r['w5']));
						$return.="<row>\n";
						$return.="<time>".substr($r['timestamp'],0,10)."</time>";
						$return.="<w0>".intval($r['w0'])."</w0>\n";
						$return.="<w1>".intval($r['w1'])."</w1>\n";
						$return.="<w2>".intval($r['w2'])."</w2>\n";
						$return.="<w3>".intval($r['w3'])."</w3>\n";
						$return.="<w4>".intval($r['w4'])."</w4>\n";
						$return.="<w5>".intval($r['w5'])."</w5>\n";
						$return.="<rowsumw0>".intval($row_sum0)."</rowsumw0>\n";
						$return.="<rowsumw1>".intval($row_sum1)."</rowsumw1>\n";
						$return.="</row>\n";															
					}
					$count++;
				}	
				$return.="</all3691>\n";
				header("Content-Type: text/xml charset:utf8");				
				echo $return;
				exit;
			case 4:	// Monat	
				$start=$now-(date("d",$now)*$day)+$tomidnight;
				$count=0;
				for($i=$start;$i<=$now;$i+=86400) {
					$from=" FROM measurements WHERE substr(datetime(timestamp,'localtime'),1,10) ";
					$where = " = '".date("Y-m-d",$i)."'";
					$select = "SELECT datetime(timestamp,'localtime') as timestamp, avg(w0) as w0, avg(w1) as w1 ,avg(w2) as w2, avg(w3) as w3, avg(w4) as w4, avg(w5) as w5, duration ".$from;
					$dbquery = $select . $where;
					$result = $db->query($dbquery);				
					foreach($result as $r) {
						$row_sum0=(floatval($r['w0'])+floatval($r['w1'])+floatval($r['w2']));
						$row_sum1=(floatval($r['w3'])+floatval($r['w4'])+floatval($r['w5']));
						$return.="<row>\n";
						$return.="<time>".substr($r['timestamp'],0,10)."</time>";
						$return.="<w0>".intval($r['w0'])."</w0>\n";
						$return.="<w1>".intval($r['w1'])."</w1>\n";
						$return.="<w2>".intval($r['w2'])."</w2>\n";
						$return.="<w3>".intval($r['w3'])."</w3>\n";
						$return.="<w4>".intval($r['w4'])."</w4>\n";
						$return.="<w5>".intval($r['w5'])."</w5>\n";
						$return.="<rowsumw0>".intval($row_sum0)."</rowsumw0>\n";
						$return.="<rowsumw1>".intval($row_sum1)."</rowsumw1>\n";
						$return.="</row>\n";														
					}
					$count++;
				}
				$return.="</all3691>\n";
				header("Content-Type: text/xml charset:utf8");				
				echo $return;
				exit;
			case 5: // Letzter Monat		  					
				$day=((date("j",$now))*86400);
				$lastmonth=$now-$day;
				$start=$lastmonth-(date("j",$lastmonth)*86400)+$tomidnight;
				$count=0;
				for($i=$start;$i<=$lastmonth;$i+=86400) {
					$from=" FROM measurements WHERE substr(datetime(timestamp,'localtime'),1,10) ";
					$where = " = '".date("Y-m-d",$i)."'";
					$select = "SELECT datetime(timestamp,'localtime') as timestamp, avg(w0) as w0, avg(w1) as w1 ,avg(w2) as w2, avg(w3) as w3, avg(w4) as w4, avg(w5) as w5, duration ".$from;
					$dbquery = $select . $where;
					$result = $db->query($dbquery);		
					foreach($result as $r) {
						if($r['timestamp']) {
							$row_sum0=(floatval($r['w0'])+floatval($r['w1'])+floatval($r['w2']));
							$row_sum1=(floatval($r['w3'])+floatval($r['w4'])+floatval($r['w5']));
							$return.="<row>\n";
							$return.="<time>".substr($r['timestamp'],0,10)."</time>";
							$return.="<w0>".intval($r['w0'])."</w0>\n";
							$return.="<w1>".intval($r['w1'])."</w1>\n";
							$return.="<w2>".intval($r['w2'])."</w2>\n";
							$return.="<w3>".intval($r['w3'])."</w3>\n";
							$return.="<w4>".intval($r['w4'])."</w4>\n";
							$return.="<w5>".intval($r['w5'])."</w5>\n";
							$return.="<rowsumw0>".intval($row_sum0)."</rowsumw0>\n";
							$return.="<rowsumw1>".intval($row_sum1)."</rowsumw1>\n";
							$return.="</row>\n";	
						}
					}
					$count++;
				}
				$return.="</all3691>\n";
				header("Content-Type: text/xml charset:utf8");
				echo $return;
				exit;			
			default: // Heute, Gestern
				$select = "SELECT datetime(timestamp,'localtime') as timestamp, avg(w0) as w0, avg(w1) as w1 ,avg(w2) as w2, avg(w3) as w3, avg(w4) as w4, avg(w5) as w5, duration ".$from;
				$result = $db->query($dbquery);
			break;
		}	
		break;	
}
$dbquery = $select . $where;
#echo $dbquery;
$result = $db->query($dbquery);
foreach($result as $r) {
	if($querytype==0) {
		$row_sum0=(((($r['w0']/1000)*$r['duration'])/3600)+((($r['w1']/1000)*$r['duration'])/3600)+((($r['w2']/1000)*$r['duration'])/3600));
		$row_sum1=(((($r['w3']/1000)*$r['duration'])/3600)+((($r['w4']/1000)*$r['duration'])/3600)+((($r['w5']/1000)*$r['duration'])/3600));
	} else {
		$row_sum0=($r['w0']+$r['w1']+$r['w2']);
		$row_sum1=($r['w3']+$r['w4']+$r['w5']);
	}
	$return.="<row>\n";
	switch ($querytype) {
		case 0:
			$return .="<time>".substr($r['timestamp'],0,10)."</time>\n";
			break;
		case 1:
			$return .="<time>".substr($r['timestamp'],0,10)."</time>\n";
			break;
		case 2:
			$return .="<time>".substr($r['timestamp'],0,10)."</time>\n";
			break;
		case 3:
			$return .="<time>".substr($r['timestamp'],0,10)." - ".substr($r['timestamp'],11,8)."</time>\n";
			break;
	}
	if($querytype==0) {
		$return.="<kw0>".round((($r['w0']/1000)*$r['duration'])/3600,2)."</kw0>\n";
		$return.="<kw1>".round((($r['w1']/1000)*$r['duration'])/3600,2)."</kw1>\n";
		$return.="<kw2>".round((($r['w2']/1000)*$r['duration'])/3600,2)."</kw2>\n";
		$return.="<kw3>".round((($r['w3']/1000)*$r['duration'])/3600,2)."</kw3>\n";
		$return.="<kw4>".round((($r['w4']/1000)*$r['duration'])/3600,2)."</kw4>\n";
		$return.="<kw5>".round((($r['w5']/1000)*$r['duration'])/3600,2)."</kw5>\n";
		$return.="<consumptionkw0>".round($row_sum0,2)."</consumptionkw0>\n";
		$return.="<consumptionkw1>".round($row_sum1,2)."</consumptionkw1>\n";
	} else {
		$return.="<w0>".intval($r['w0'])."</w0>\n";
		$return.="<w1>".intval($r['w1'])."</w1>\n";
		$return.="<w2>".intval($r['w2'])."</w2>\n";
		$return.="<w3>".intval($r['w3'])."</w3>\n";
		$return.="<w4>".intval($r['w4'])."</w4>\n";
		$return.="<w5>".intval($r['w5'])."</w5>\n";
	}

	
	$return.="</row>\n";	
}
	$return.="</all3691>\n";
	header("Content-Type: text/xml charset:utf8");
	echo $return;
?>