// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   actor_view.c   -   Anzeigen der Aktordaten aus dem Shared Memory                                              **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2009 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <time.h>
#include <sys/time.h>
#include <unistd.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include "../sqlite/sqlite-3.7.3_arm/sqlite3.h"
#include "at91gpio.h"
#include "all_i2c.h"
#include "i2c_chips.h"
#include "sqldb.h"
#include "sensor_demon.h"
#include "shm_use.h"



// *****   Hauptschleife   *****

int main(int argc,char **argv)
	{
	struct s_shm_actordata*		shm_actor_w_data;						// Aktordaten im Shared-RAM
	struct s_shm_actordata*		shm_actor_r_data;						// Aktordaten im Shared-RAM
	unsigned long int					t;
	int												shID;


	// auf existierendes Shared Memory fr Aktordaten Write zugreifen
	shID = shmget(SHM_ID_ACTOR_W_DATA,SHM_ACTOR_W_DATA_SIZE,0666);
	if (shID >= 0)
		{
		shm_actor_w_data = shmat(shID,0,0);
		if (shm_actor_w_data == (struct s_shm_actordata *)-1)
			{
			printf("Problem beim Zugriff auf ACTOR_W_DATA shared memory !\n");
			goto ende;
			}
		else
			{
			// printf("SHM_Actor_w_data OK.\n");
			}
		}
	else
		{
		// shmget lief schief
		printf("shmget fr SHM_Actor_w_data war erfolglos ! (shm_create nicht aufgerufen ?)\n");
		goto ende;
    }

	// auf existierendes Shared Memory fr Aktordaten Read zugreifen
	shID = shmget(SHM_ID_ACTOR_R_DATA,SHM_ACTOR_R_DATA_SIZE,0666);
	if (shID >= 0)
		{
		shm_actor_r_data = shmat(shID,0,0);
		if (shm_actor_r_data == (struct s_shm_actordata *)-1)
			{
			printf("Problem beim Zugriff auf ACTOR_R_DATA shared memory !\n");
			goto ende;
			}
		else
			{
			// printf("SHM_Actor_r_data OK.\n");
			}
		}
	else
		{
		// shmget lief schief
		printf("shmget fr SHM_Actor_r_data war erfolglos ! (shm_create nicht aufgerufen ?)\n");
		goto ende;
    }

looping:
	usleep(1000000);																			// 1000 ms warten
	printf("\n");
	for(t = 0;t < MAX_LOGICAL_ACTORS;t++)
		{
		if(shm_actor_r_data[t].value_long > -204800000)
			{
			printf("Actor %ld: Soll: %ld, Ist:%ld",t,shm_actor_w_data[t].value_long,shm_actor_r_data[t].value_long);
			if (shm_actor_r_data[t].value_float >= 0) printf (", %4.2f W",shm_actor_r_data[t].value_float);
			printf("\n");
			}
		}
	goto looping;


ende:
	return(0);
	}
