// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   adc_shm_write.c   -   Schreiben der Daten eines ADC-Messpunkts in das Shared Memory                           **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2011 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/shm.h>
#include "shm_use.h"





// *****   Hauptschleife   *****

int main(int argc,char **argv)
	{
	int												rw = 0;
	signed long int						nummer;
	int												shID;
	struct s_shm_adc*					adc_data;										// ADC-daten im Shared-RAM
	signed long int						t;
	unsigned short int				cmd_adc[6];									// ADC-Sollwerte von der Kommandozeile

	if (argc != 8)
		{
		printf("ERROR: usage: adc_shm_write id 0 1 2 3 4 5  (writes data to a distginct id)\n");
		rw = -2;
		goto ende;
		}

	nummer = atol(argv[1]);																// Nummer aus der Commandline holen
	if (nummer < 0)
		{
		printf("ERROR: id must be positive or 0 !\n");
		rw = -3;
		goto ende;
		}
	if (nummer >= SHM_ID_ADCCOUNT)
		{
		printf("ERROR: id must be less than SHM_ID_ADCCOUNT (%d) !\n",SHM_ID_ADCCOUNT);
		rw = -3;
		goto ende;
		}

	cmd_adc[0] = atol(argv[2]);														// Werte aus der Commandline holen
	cmd_adc[1] = atol(argv[3]);
	cmd_adc[2] = atol(argv[4]);
	cmd_adc[3] = atol(argv[5]);
	cmd_adc[4] = atol(argv[6]);
	cmd_adc[5] = atol(argv[7]);



	// auf existierendes Shared Memory fr ADC zugreifen
	shID = shmget(SHM_ID_ADC,SHM_ADC_SIZE,0666);
	if (shID >= 0)
		{
		adc_data = shmat(shID,0,0);
		if (adc_data == (struct s_shm_adc *)-1)
			{
			printf("Problem beim Zugriff auf ADC shared memory !\n");
			goto ende;
			}
		else
			{
			// printf("SHM_ADC OK.\n");
			}
		}
	else
		{
		// shmget lief schief
		printf("shmget fr SHM_ADC war erfolglos ! (shm_create nicht aufgerufen ?)\n");
		goto errorende;
    }



	// Status des Messpunkts setzen
	printf("id  : %ld\n",nummer);													// ID
	for (t = 0;t < 6;t++)
		{
		adc_data[nummer].adc[t] = cmd_adc[t];								// Wert
		}

	rw = 0;
	goto ende;



errorende:
	rw = -1;
ende:
	return(rw);
	}
