// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   demon_readstatus.c   -   Anzeigen der Daten eines Demons aus dem Shared Memory                                **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2011 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <time.h>
#include <sys/time.h>
#include <unistd.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include "shm_use.h"



// -----   lput(source,destination,laenge) - Sourcestring in Destinationstring anzeigen   -----

// void lput(char source[],char *destination,signed long int laenge)
void lput(char source[],char *destination,signed long int laenge)
	{
	signed long int t;


	for (t = 0;t < laenge;t++)
		{
		destination[t] = 32;
		}
	destination[laenge] = 0;

	for (t = 0;t < laenge;t++)
		{
		if (source[t] == 0) goto ende;
		destination[t] = source[t];
		}

ende: ;
	}



// *****   Hauptschleife   *****

int main(int argc,char **argv)
	{
	int												rw = 0;
	signed short int					nummer;
	struct tm									*tcrap;
	signed long int						old_ti[SHM_ID_DEMONCOUNT];
	char											ep[80];
	char											bs[80];
	signed long int						t;


	if (argc != 2)
		{
		printf("ERROR: usage: demon_readstatus demon_id  (shows data for a specific demon)\n");
		printf("              demon_readstatus -t        (shows a table for all demons like top, reload every second)\n");
		printf("              demon_readstatus -T        (shows a table for all demons like top, only once)\n");
		rw = -2;
		goto ende;
		}

	// auf existierendes Shared Memory fr Demonstatus zugreifen
	if (use_my_demonstatus_shm(0) != 1) goto errorende;

	if (strcmp(argv[1],"-t") == 0)
		{
		goto top_mode;
		}
	if (strcmp(argv[1],"-T") == 0)
		{
		goto top_mode;
		}
	nummer = atoi(argv[1]);																// Nummer aus der Commandline holen
	if (nummer < 0)
		{
		printf("ERROR: id must be positive or 0 !\n");
		rw = -3;
		goto ende;
		}
	if (nummer >= SHM_ID_DEMONCOUNT)
		{
		printf("ERROR: id must be less than SHM_ID_DEMONCOUNT (%d) !\n",SHM_ID_DEMONCOUNT);
		rw = -3;
		goto ende;
		}



	// Status von Demon anzeigen
	printf("id            : %ld\n",my_demonstatus_data[nummer].demon_id);					// ID
	printf("name          : \"%s\"\n",my_demonstatus_data[nummer].name_string);		// Name
	printf("version       : \"%s\"\n",my_demonstatus_data[nummer].version_string);// Versionsnummer

	tcrap = localtime(&my_demonstatus_data[nummer].last_boot);
	printf("start time    : %04d-%02d-%02d %02d:%02d:%02d\n",tcrap->tm_year+1900,tcrap->tm_mon+1,tcrap->tm_mday,tcrap->tm_hour,tcrap->tm_min,tcrap->tm_sec);

	tcrap = localtime(&my_demonstatus_data[nummer].last_activity);
	printf("last operation: %04d-%02d-%02d %02d:%02d:%02d\n",tcrap->tm_year+1900,tcrap->tm_mon+1,tcrap->tm_mday,tcrap->tm_hour,tcrap->tm_min,tcrap->tm_sec);

	printf("ti            : %ld\n",my_demonstatus_data[nummer].ti);								// Counter
	printf("debug         : \"%s\"\n",my_demonstatus_data[nummer].debug_message);	// letzte Debug-Meldung
	printf("error         : \"%s\"\n",my_demonstatus_data[nummer].error_message);	// letzte Fehlermeldung
	printf("status numeric: %ld\n",my_demonstatus_data[nummer].status_long);			// Status als Long
	printf("status string : \"%s\"\n",my_demonstatus_data[nummer].status_string);	// Status als String
	rw = 0;
	goto ende;



top_mode:
top_mode_2:
	printf("\033[;H\033[2J");															// VT100-Code zum Bildschirmlschen
	// printf("\033[;H");																		// VT100-Code fr Cursor Home
	printf("ID  ");																				//  3 + 1 Stellen
	printf("Name....... ");																// 11 + 1 Stellen
	printf("Vers. ");																			//  5 + 1 Stellen
	printf("Start Time......... ");												// 19 + 1 Stellen	
	printf("Last.... ");																	//  8 + 1 Stellen	
	printf("TI......");																		//  8 + 0 Stellen
	printf("dif ");																				//  3 + 1 Stellen
	printf("Sts ");																				//  3 + 1 Stellen
	printf("Status.... ");																// 10 + 1 Stellen
	printf("Error..... ");																// 10 + 1 Stellen
	printf("Debug...........\n");													// 16 + 0 Stellen

	// lput("111222333444555666777888999000\n",bs,20);
	// printf("1: \"%s\"\n",bs);

	for (t = 0;t < SHM_ID_DEMONCOUNT;t++)
		{
		if ((t == 0) || (my_demonstatus_data[t].demon_id != 0))
			{
			sprintf(ep,"%ld",t);															// ID 3 + 1 Stellen
			lput(ep,bs,3);
			printf("%s ",bs);

			lput(my_demonstatus_data[t].name_string,bs,11);		// Name 11 + 1 Stellen
			printf("%s ",bs);

			lput(my_demonstatus_data[t].version_string,bs,5);	// Version 5 + 1 Stellen
			printf("%s ",bs);

			tcrap = localtime(&my_demonstatus_data[t].last_boot); // Start Time 19 + 1 Stellen
			printf("%04d-%02d-%02d %02d:%02d:%02d ",tcrap->tm_year+1900,tcrap->tm_mon+1,tcrap->tm_mday,tcrap->tm_hour,tcrap->tm_min,tcrap->tm_sec);

			tcrap = localtime(&my_demonstatus_data[t].last_activity); // last Entry 8 + 1 Stellen
			printf("%02d:%02d:%02d ",tcrap->tm_hour,tcrap->tm_min,tcrap->tm_sec);

			sprintf(ep,"%ld",my_demonstatus_data[t].ti);			// TI 8 + 0 Stellen
			lput(ep,bs,8);
			printf("%s",bs);

			if (old_ti[t] == 0) old_ti[t] = my_demonstatus_data[t].ti;
			sprintf(ep,"%ld",my_demonstatus_data[t].ti - old_ti[t]); // TI 3 + 1 Stellen
			lput(ep,bs,3);
			printf("%s ",bs);

			sprintf(ep,"%ld",my_demonstatus_data[t].status_long); // numerischer Status 3 + 1 Stellen
			lput(ep,bs,3);
			printf("%s ",bs);

			lput(my_demonstatus_data[t].status_string,bs,10);	// string Status 10 + 1 Stellen
			printf("%s ",bs);

			lput(my_demonstatus_data[t].error_message,bs,10);	// string Error 10 + 1 Stellen
			printf("%s ",bs);

			lput(my_demonstatus_data[t].debug_message,bs,16);	// string Debug 16 + 0 Stellen
			printf("%s",bs);


			old_ti[t] = my_demonstatus_data[t].ti;
			printf("\n");
			}
		}

	if (strcmp(argv[1],"-t") == 0)
		{
		// sleep(1);
		usleep(500000);
		goto top_mode_2;
		}
	goto ende;


errorende:
	rw = -1;
ende:
	return(rw);
	}
