// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   hwdetect.c   -   ALL4500/5000 Unterscheidung finden und in DB eintragen                                       **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2009 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// **********************************************************************************************************************



#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "../sqlite/sqlite-3.7.3_arm/sqlite3.h"
#include "sqldb.h"
#include "at91gpio.h"
#include "all_i2c.h"
#include "i2c_chips.h"



// *****   Hauptprogramm   *****

int main(int argc,char **argv)
	{
	signed short int rw = -1;


	// printf("Determinig Allnet system hardware...\n");


	gpio_devmem_open();																		// GPIOs oeffnen
	gpio_port_init_output(PORT_B,16);											// PB16 ist der Test-Eingang
	gpio_port_write(PORT_B,16,0);													// L
	usleep(100000);																				// 0.1 Sekunde warten
	gpio_port_write(PORT_B,16,1);													// H
	gpio_port_init_input(PORT_B,16);											// auf Eingang setzen
	usleep(100000);																				// 0.1 Sekunde warten

	if(gpio_port_read(PORT_B,16) == 0) rw = 4500;					// L: ALL4500
	if(gpio_port_read(PORT_B,16)  > 0) rw = 5000;					// H: ALL5000


	sqldb_write_long("/sys/hardware/numeric_model",rw);

	if(rw == 4500)
		{
		printf("ALL4500\n");
		sqldb_write_long("/sys/hardware/all4500",1);
		}
	else
		{
		sqldb_write_long("/sys/hardware/all4500",0);
		}

	if(rw == 5000)
		{
		printf("ALL5000\n");
		sqldb_write_long("/sys/hardware/all5000",1);
		}
	else
		{
		sqldb_write_long("/sys/hardware/all5000",0);
		}

	return(rw);
	}

