// **********   i2c_chips.h - Funktionen zur Bedienung verschiedener Bausteine   **********



// *****   Globale Variablen   *****

extern unsigned char				rtc_sekunde;
extern unsigned char				rtc_minute;
extern unsigned char				rtc_stunde;
extern unsigned char				rtc_tag;
extern unsigned char				rtc_monat;
extern unsigned short int		rtc_jahr;
extern char									file_log[];

extern unsigned char				t_poti0;
extern unsigned char				t_poti1;
extern unsigned char				t_poti2;
extern unsigned char				t_poti3;
extern unsigned char				t_poti4;
extern unsigned char				t_poti5;
extern unsigned char				t_r0;
extern unsigned char				t_g0;
extern unsigned char				t_b0;
extern unsigned char				t_w0;
extern unsigned char				t_r1;
extern unsigned char				t_g1;
extern unsigned char				t_b1;
extern unsigned char				t_w1;
extern unsigned char				t_ir;
extern unsigned char				t_fw_major;
extern unsigned char				t_fw_minor;
extern unsigned char				t_ir;
extern unsigned char				t_ircounter;
extern unsigned char				t_dim0;
extern unsigned char				t_dim1;
extern double								t_temperature_int;
extern double								t_temperature_ext;
extern double								t_humidity_ext;
extern signed short int			physical_measurementtype_rotator;
extern signed short int			physical_measurementtype_counter;
extern signed short int			physical_measurementtype_cycles;



// *****   Funktions-Prototypen   *****

signed long int			all_i2c_chip_ads1100_read						(unsigned char busnummer,unsigned char address,unsigned char bits);
signed long int			all_i2c_chip_all3025_read_counter		(unsigned char busnummer);
signed long int			all_i2c_chip_all4035_read_counter		(unsigned char busnummer);
signed long int			all_i2c_chip_all3022_read_voltage		(unsigned char busnummer,unsigned char channel);
signed long int			all_i2c_chip_all4023_read_voltage		(unsigned char busnummer,unsigned char channel);
signed long int			all_i2c_chip_all3032_read_brightness(unsigned char busnummer);
signed long int			all_i2c_chip_all4033_read_voltage		(unsigned char busnummer);
signed long int			all_i2c_chip_dsdx015a2r_read_pressure(unsigned char busnummer);
signed long int			all_i2c_chip_hdi0811_read_pressure	(unsigned char busnummer);
signed long int			all_i2c_chip_bmp085_read_pressure		(unsigned char busnummer);
signed long int			all_i2c_chip_sht71_read_humidity_nw	(unsigned char busnummer);
signed long int			all_i2c_chip_sht71_read_humidity		(unsigned char busnummer);
signed long int			all_i2c_chip_sht71_read_temp				(unsigned char busnummer);
signed long int			all_i2c_chip_sht71_read_temp_nw			(unsigned char busnummer);
signed long int			all_i2c_chip_lm75_read_temp					(unsigned char busnummer,unsigned char address);
signed long int			all_i2c_chip_lm92_read_temp					(unsigned char busnummer,unsigned char address);
signed long int			all_i2c_chip_lm92_read_temp_nopointer (unsigned char busnummer,unsigned char address);
signed long int			all_i2c_chip_pcf8574_read						(unsigned char busnummer,unsigned char address);
unsigned char				all_i2c_chip_pcf8574_write					(unsigned char busnummer,unsigned char address,unsigned char wert);
signed long int			all_i2c_chip_pcf8574a_read					(unsigned char busnummer,unsigned char address);
unsigned char				all_i2c_chip_pcf8574a_write					(unsigned char busnummer,unsigned char address,unsigned char wert);
struct tm						all_i2c_chip_pcf8583_read_time			(unsigned char busnummer,unsigned char address);
unsigned char				all_i2c_chip_pcf8583_write_time			(unsigned char busnummer,unsigned char address,struct tm zeit);
signed long int			all_i2c_chip_rfid001_read_cardid		(unsigned char busnummer,char *string_value);
unsigned char				bcd2dez															(unsigned char BCD);
unsigned char				dez2bcd															(unsigned char natural_binary);
double							simplified_ads1100_read							(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay,unsigned char address,unsigned char bits);
double							simplified_all3025_read_counter			(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay);
double							simplified_all4035_read_counter			(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay);
double							simplified_all3021_read_voltage			(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay);
double							simplified_all3022_read_voltage			(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay,unsigned char channel);
double							simplified_all4023_read_voltage			(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay,unsigned char channel);
double							simplified_all3032_read_brightness	(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay);
double							simplified_all4033_read_voltage			(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay);
void								simplified_all5000_led_set					(unsigned short int led_nummer,unsigned char schaltwunsch);
double							simplified_dsdx015a2r_read_pressure	(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay);
double							simplified_hdi0811_read_pressure		(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay);
double							simplified_bmp085_read_pressure			(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay);
double							simplified_sht71_read_humidity			(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay);
double							simplified_sht71_read_humidity_nw		(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay);
double							simplified_sht71_read_temp					(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay);
double							simplified_sht71_read_temp_nw				(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay);
double							simplified_lm75_read_temp						(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay,unsigned char address);
double							simplified_lm92_read_temp						(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay,unsigned char address);
struct tm						simplified_pcf8583_read_time				(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay,unsigned char address);
unsigned char				simplified_pcf8583_write_time				(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay,unsigned char address,struct tm zeit);
signed long int			simplified_pcf8574_read							(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay,unsigned char address);
unsigned char				simplified_pcf8574_write						(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay,unsigned char address,unsigned char wert);
signed long int			simplified_pcf8574a_read						(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay,unsigned char address);
unsigned char				simplified_pcf8574a_write						(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay,unsigned char address,unsigned char wert);
double							simplified_rfid001_read_cardid			(unsigned char busnummer,unsigned char bus_group,unsigned char bus_port,unsigned long int bus_delay,char *string_value);
unsigned char				all_i2c_chip_dualrgb_read						(unsigned char busnummer,unsigned long int bus_delay);
unsigned char				all_i2c_chip_dualrgb_write					(unsigned char busnummer,unsigned long int bus_delay,unsigned char r0,unsigned char g0,unsigned char b0,unsigned char w0,unsigned char r1,unsigned char g1,unsigned char b1,unsigned char w1,unsigned char dim0,unsigned char dim1);
unsigned char				all_i2c_chip_ltc4258_writepoe				(unsigned char busnummer,unsigned char poe_chipid,unsigned char poe_portnummer,unsigned char poe_schaltwunsch);
