// **********   plugwise_demon.h - Include-File fr den Plugwise-Demon   **********



// *****   Globale Variablen   ******

#define											PLUGWISE_DEMON_VERSION "1.81"
#define											PLUGWISE_MAX_SLAVES 128

extern unsigned short int		cache_max_slaves;
extern signed char					cache_slave_enabled[PLUGWISE_MAX_SLAVES];
extern char									cache_slave_mac_address[PLUGWISE_MAX_SLAVES][17];
extern signed long int			cache_slave_mapfrom_actor[PLUGWISE_MAX_SLAVES];
extern signed long int			cache_slave_mapto_sensor[PLUGWISE_MAX_SLAVES];
extern signed long int			cache_slave_value[PLUGWISE_MAX_SLAVES];
extern double								cache_slave_watt[PLUGWISE_MAX_SLAVES];
extern signed long int			plugwise_reload_counter;
extern char									plugwise_comport[20];
extern signed long int			read_delay;
extern signed long int			plugwise_max_retries;
extern int									shID;
extern struct s_shm_actordata*	shm_actor_r_data;
extern struct s_shm_actordata*	shm_actor_w_data;

// CRC parameters for Plugwise (default values are for CRC-32):
const int										order = 16;
const unsigned long					polynom = 0x11021;
const int										direct = 0;
const unsigned long					crcinit = 0;
const unsigned long					crcxor = 0;
const int										refin = 0;
const int										refout = 0;
unsigned long								crcmask;
unsigned long								crchighbit;
unsigned long								crcinit_direct;
unsigned long								crcinit_nondirect;
unsigned long								crctab[16];



// *****   Funktions-Prototypen   *****

void							cache_setzedefault				(void);
void							pldemon_readconfig				(void);
signed long int		plugwise_query						(unsigned short int dosennummer);
signed long int		plugwise_query2						(unsigned short int dosennummer,unsigned short int tries);
double						plugwise_query_power			(unsigned short int dosennummer);
double						plugwise_query_power2			(unsigned short int dosennummer,unsigned short int tries);
signed long int		plugwise_schalte					(unsigned short int dosennummer,unsigned short int schaltwunsch);
signed long int		plugwise_schalte2					(unsigned short int dosennummer,unsigned short int schaltwunsch,unsigned short int tries);
int								rs232_open								(char device[],unsigned long int baudrate);
long							get_ms_now								(void);
unsigned long			reflect										(unsigned long crc, int bitnum);
void							generate_crc_table				(void);
unsigned long			crcbitbybit								(char* p,unsigned long len);
signed long int		plugwise_ll_send					(char port[],char circlemac[],signed short int befehl);
void							midstring									(char langer_string[],unsigned short int anfang, unsigned short int laenge,char *ergebnis);
signed char				find_data									(char input_string[],unsigned short int end_length,char search_pattern[], char *result_string);
unsigned int			htoi											(char s[]);
int								plgwsd_initport						(int fd);
int								readport									(int fd,char *result);
int								read_serialport						(int fd,char *buf,int bytes,int timeout);
float							HexToFloat								(char *hex);
unsigned int			htoi											(char s[]);
void							plgwsd_send_powercode			(int fd, char circlemac[],char action[]);
signed long int		plgwsd_get_status					(int fd,char circlemac[]);
float							plgwsd_get_calibration		(int fd, char circlemac[]);




