// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   plugwise_set.c   -   Commandlinetool zum Steuern von Plugwise-Steckdosen                                      **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2009 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <fcntl.h>
#include "../sqlite/sqlite-3.7.3_arm/sqlite3.h"
#include "sqldb.h"


// *****   udp_send() - Daten senden   *****

void udp_send(char zielip[],unsigned short int portnummer,unsigned char *daten,unsigned short int laenge)
	{
	int							udp_socket;
	struct					sockaddr_in steuerstruct;

	// printf("udp_send an %s:%d, %d Bytes.\n",zielip,portnummer,laenge);

	if ((udp_socket = socket(PF_INET,SOCK_DGRAM,IPPROTO_UDP)) >= 0) // UDP-Socket anlegen
		{
		// Construct the server sockaddr_in structure
		memset(&steuerstruct,0,sizeof(steuerstruct));				// Struct auf 0 setzen
		steuerstruct.sin_family = AF_INET;									// Internet/IP
		steuerstruct.sin_addr.s_addr = inet_addr(zielip);		// IP-Addresse
		steuerstruct.sin_port = htons(portnummer);					// UDP-Portnummer

		sendto(udp_socket,daten,laenge,0,(struct sockaddr *) &steuerstruct,sizeof(steuerstruct));
		close(udp_socket);
		// printf("OK.\n");
		}
	}



void print_usage()
	{
	printf("USAGE: plugwise_set slave_number parameter\n");
	exit(0);
	}



// *****   Testprogramm   *****

int main(int argc,char **argv)
	{
	unsigned short int			slave_number;
	unsigned short int			schalt_parameter;
	unsigned char						k[54];
	unsigned short int			udp_rx_port = 54321;					// TCP Socket fr Client/Server Verbindung
	char										udp_rx_username[1024] = "";		// Username fr UDP-Verbindung
	char										udp_rx_password[1024] = "";		// Passwort fr UDP-Verbindung
	unsigned char						j;
	unsigned char						c;
	unsigned char						l;
	char										blubb[8];											// Puffer fr Zahlenkonvertierung



 	if (argc != 3)
		{
		print_usage();
		}


		slave_number = atoi(argv[1]);
  	schalt_parameter = atoi(argv[2]);

		udp_rx_port = sqldb_read_long("/control/plugwise/server/udpport");
		sqldb_read_string("/control/plugwise/server/username",udp_rx_username);
		sqldb_read_string("/control/plugwise/server/password",udp_rx_password);

	printf("plugwise_set_udp(%d:%d), %s:%d, User:\"%s\", Pass:\"%s\"\n",slave_number,schalt_parameter,"127.0.0.1",udp_rx_port,udp_rx_username,udp_rx_password);


						
						memset(k,0,54);

						l = 0;
						for(j = 0;j < 20;j++)
							{
							c = udp_rx_username[j];
							if (c == 0) goto skip1;
							k[l++] = c;
							}
skip1:
						l = 20;
						for(j = 0;j < 20;j++)
							{
							c = udp_rx_password[j];
							if (c == 0) goto skip2;
							k[l++] = c;
							}
skip2:
						sprintf(blubb,"%04d",slave_number);
						k[40] = blubb[ 0];
						k[41] = blubb[ 1];
						k[42] = blubb[ 2];
						k[43] = blubb[ 3];
						sprintf(blubb,"%05d",schalt_parameter);
						k[44] = blubb[ 0];
						k[45] = blubb[ 1];
						k[46] = blubb[ 2];
						k[47] = blubb[ 3];
						k[48] = blubb[ 4];
						k[49] = 0;
						k[50] = 0;
						k[51] = 0;
						k[52] = 0;
						k[53] = 0;

						udp_send("127.0.0.1",udp_rx_port,k,54);

	return(0);
	}

