// **********   poe.c - Testprogramm fr POE-Ansteuerung (fr Allnet 24-Port Switch ALL0484WMP)   **********


#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "xml_lib.h"
#include "htmlstuff.h"



// *****   Globale Variablen   *****

unsigned char switch_ip[20] = "192.168.2.1";						// IP-Adresse des Netzwerkswitches
unsigned long switch_number_of_ports = 24;							// Anzahl PoE-fhier Netzwerkports
char tmp_filename[90] = "/tmp/poetmp.txt";							// Name der zu verwendenden Hilfsdatei



// *****   Testprogramm   *****

int main(int argc,char **argv)
	{
	int rw = 0;																						// Funktions-Rckwert
	unsigned char poe_portnummer = 0;											// Nummer des zu schaltenden Ports
	unsigned char poe_schaltwunsch = 0;										// 0/1, je nachdem ob PoE aus/eingeschaltet werden soll
	char http_challenge[80];															// Challenge/Response Token fr uthentifizierung des Webservers
	char kommando[4096];																	// Puffer zum Zusammenbau von Shellkommandos
	char url[2048];
	char k2[99];
	signed int x;
	char puffer[32767];
	char tmppuffer[32767];
	char buf1[2048];
	char buf2[2048];
	char tmpstr[99];
	signed int i;
	signed int j;
	unsigned char output_flag = 0;												// Soll eine Output-Datei generiert werden ?
	unsigned char schalt_flag = 0;												// muss geschaltet werden ?
	char output_filename[255];														// Filename fr die Output-Datei
	char poe_port_on[99];																	// PoE Power ein/Aus
	unsigned int poe_port_linkspeed[99];									// Link Geschwindigkeit in Mbit
	char poe_port_linkup[99];															// Link Up/Down
	signed int poe_port_class[99];											// erkannte PoE Class (0...4)
	unsigned int poe_port_current[99];										// tatschlich flieender Strom in mA
	FILE *f;																							// Filepointer
	char *zp;


 	if ((argc != 2) && (argc != 3))
		{
		printf("USAGE: poe port_number 0/1 (switches the selected port off or on)\n");
		printf("   or: poe filename        (Queries Port status and outputs XML to file)\n");
		return(-1);
		}
  	
	if (argc == 3)
		{
  	poe_portnummer = atoi(argv[1]);
  	poe_schaltwunsch = atoi(argv[2]);
		output_flag = 0;
		schalt_flag = 1;
		if (poe_portnummer < 1) poe_portnummer = 1;
		if (poe_portnummer > switch_number_of_ports) poe_portnummer = switch_number_of_ports;
		if (poe_schaltwunsch != 0) poe_schaltwunsch = 1;
		}
	else
		{
  	strcpy(output_filename,argv[1]);
		output_flag = 1;
		schalt_flag = 0;
		}


	sleep(2); // 2 Sekunden warten

	// Als Erstes muss auf die Login-Seite zugegriffen werden, um das Challenge-Token dieser Verbindung zu erfahren
	sprintf(url,"http://%s/login2.htm",switch_ip);
	sprintf(kommando,"wget --cookies=on --keep-session-cookies --save-cookies=/tmp/poecookie.txt \"%s\" -O %s --quiet",url,tmp_filename);
	// printf("Kommando: xxx%sxxx\n",kommando);

	sprintf(k2,"rm %s 2>/dev/null",tmp_filename);
	system(k2);
	system(kommando);

	readfileinstring(tmp_filename,puffer);
	x = html_parse_string(puffer,"Challenge\" value=\"","\">\n<input type=\"hidden\" name=\"Response",http_challenge);
	// printf("x=%d, challenge=\"%s\"\n",x,http_challenge);

	sleep(1); // 1 Sekunde warten

	// Nun knnen wir mit diesem Token den Login durchfhren
	sprintf(url,"http://%s/cgi/login.cgi?Username=admin&Password=admin&Challenge=%s&Response=HTTP/1.1",switch_ip,http_challenge);
	sprintf(kommando,"wget --cookies=on --keep-session-cookies --save-cookies=/tmp/poecookie.txt \"%s\" -O %s --quiet",url,tmp_filename);
	// printf("Kommando: xxx%sxxx\n",kommando);
	system(kommando);

	sleep(1); // 1 Sekunde warten

	// Jetzt mssen wir den Status der POE-Ports abholen
	sprintf(url,"http://%s/POE.htm",switch_ip);
	sprintf(kommando,"wget --cookies=on --load-cookies=/tmp/poecookie.txt --keep-session-cookies --save-cookies=/tmp/poecookie.txt \"%s\" -O %s --quiet",url,tmp_filename);
	// printf("Kommando: xxx%sxxx\n",kommando);

	sprintf(k2,"rm %s 2>/dev/null",tmp_filename);
	system(k2);
	system(kommando);

	readfileinstring(tmp_filename,puffer);

	for (x = 0;x <= switch_number_of_ports;x++)
		{
		poe_port_on[x] = 0;
		poe_port_linkup[x] = 0;
		poe_port_linkspeed[x] = 0;
		poe_port_class[x] = -1;
		poe_port_current[x] = 0;
		}

	// PoE Ein/Aus Status
	i = html_parse_string(puffer,"\"POE1\" VALUE=\"8\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[1] = 1;
		}
	i = html_parse_string(puffer,"\"POE1\" VALUE=\"4\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[2] = 1;
		}
	i = html_parse_string(puffer,"\"POE1\" VALUE=\"2\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[3] = 1;
		}
	i = html_parse_string(puffer,"\"POE1\" VALUE=\"1\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[4] = 1;
		}

	i = html_parse_string(puffer,"\"POE2\" VALUE=\"8\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[5] = 1;
		}
	i = html_parse_string(puffer,"\"POE2\" VALUE=\"4\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[6] = 1;
		}
	i = html_parse_string(puffer,"\"POE2\" VALUE=\"2\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[7] = 1;
		}
	i = html_parse_string(puffer,"\"POE2\" VALUE=\"1\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[8] = 1;
		}

	i = html_parse_string(puffer,"\"POE3\" VALUE=\"8\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[9] = 1;
		}
	i = html_parse_string(puffer,"\"POE3\" VALUE=\"4\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[10] = 1;
		}
	i = html_parse_string(puffer,"\"POE3\" VALUE=\"2\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[11] = 1;
		}
	i = html_parse_string(puffer,"\"POE3\" VALUE=\"1\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[12] = 1;
		}

	i = html_parse_string(puffer,"\"POE4\" VALUE=\"8\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[13] = 1;
		}
	i = html_parse_string(puffer,"\"POE4\" VALUE=\"4\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[14] = 1;
		}
	i = html_parse_string(puffer,"\"POE4\" VALUE=\"2\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[15] = 1;
		}
	i = html_parse_string(puffer,"\"POE4\" VALUE=\"1\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[16] = 1;
		}

	i = html_parse_string(puffer,"\"POE5\" VALUE=\"8\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[17] = 1;
		}
	i = html_parse_string(puffer,"\"POE5\" VALUE=\"4\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[18] = 1;
		}
	i = html_parse_string(puffer,"\"POE5\" VALUE=\"2\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[19] = 1;
		}
	i = html_parse_string(puffer,"\"POE5\" VALUE=\"1\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[20] = 1;
		}

	i = html_parse_string(puffer,"\"POE6\" VALUE=\"8\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[21] = 1;
		}
	i = html_parse_string(puffer,"\"POE6\" VALUE=\"4\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[22] = 1;
		}
	i = html_parse_string(puffer,"\"POE6\" VALUE=\"2\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[23] = 1;
		}
	i = html_parse_string(puffer,"\"POE6\" VALUE=\"1\" ","></td>",tmpstr);
	if (i >= 0)
		{
		i = strcmp(tmpstr,"checked");
		if (i == 0) poe_port_on[24] = 1;
		}


	// PoE Strom in mA
	strcpy(tmppuffer,puffer); // Puffer retten
	i = html_parse_string(puffer,"PSE Current</td>","</tr>",buf2);
	if (i >= 0)
		{
		// printf("Current Buffer1...8:\"%s\"\n",buf2);
		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[1] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[2] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[3] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[4] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[5] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[6] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[7] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[8] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		}


	zp = strstr(puffer,"PSE Current</td>");
	if (zp > 0)
		{
		i = zp - &puffer[0] + 4;
		for (j = 0;j < i;j++) puffer[j] = '.';
		}
	i = html_parse_string(puffer,"PSE Current</td>","</tr>",buf2);
	if (i >= 0)
		{
		// printf("Current Buffer9...16:\"%s\"\n",buf2);
		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[9] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[10] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[11] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[12] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[13] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[14] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[15] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[16] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		}


	zp = strstr(puffer,"PSE Current</td>");
	if (zp > 0)
		{
		i = zp - &puffer[0] + 4;
		for (j = 0;j < i;j++) puffer[j] = '.';
		}
	i = html_parse_string(puffer,"PSE Current</td>","</tr>",buf2);
	if (i >= 0)
		{
		// printf("Current Buffer17...124:\"%s\"\n",buf2);
		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[17] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[18] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[19] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[20] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[21] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[22] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[23] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","</td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"to ","mA",tmpstr);
			if (i > 0)
				{
				poe_port_current[24] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		}




	// PoE Class
	strcpy(puffer,tmppuffer); // Puffer zurckholen
	i = html_parse_string(puffer,"POE Class</td>","</tr>",buf2);
	if (i >= 0)
		{
		// printf("Class Buffer1...8:\"%s\"\n",buf2);
		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[1] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[2] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[3] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[4] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[5] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[6] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[7] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[8] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		}


	zp = strstr(puffer,"POE Class</td>");
	if (zp > 0)
		{
		i = zp - &puffer[0] + 4;
		for (j = 0;j < i;j++) puffer[j] = '.';
		}
	i = html_parse_string(puffer,"POE Class</td>","</tr>",buf2);
	if (i >= 0)
		{
		// printf("Current Buffer9...16:\"%s\"\n",buf2);
		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[9] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[10] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[11] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[12] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[13] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[14] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[15] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[16] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		}


	zp = strstr(puffer,"POE Class</td>");
	if (zp > 0)
		{
		i = zp - &puffer[0] + 4;
		for (j = 0;j < i;j++) puffer[j] = '.';
		}
	i = html_parse_string(puffer,"POE Class</td>","</tr>",buf2);
	if (i >= 0)
		{
		// printf("Class Buffer17...124:\"%s\"\n",buf2);
		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[17] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[18] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[19] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[20] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[21] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[22] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[23] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		i = html_parse_string(buf2,"center\">","/td>",buf1);
		if (i > 0)
			{
			i = html_parse_string(buf1,"Class ","<",tmpstr);
			if (i > 0)
				{
				poe_port_class[24] = atoi(tmpstr);
				}
			zp = strstr(buf2,"</td>");
			if (zp > 0)
				{
				i = zp - &buf2[0] + 4;
				for (j = 0;j < i;j++) buf2[j] = '.';
				}
			}

		}




	for (x = 1;x <= switch_number_of_ports;x++)
		{
		// printf("POE Port[%d]=%d\n",x,poe_port_on[x]);
		}


	// und nun kann in dem Array der gewnschte Port ein- bzw. ausgeschaltet werden
	if (schalt_flag != 0)
		{
		poe_port_on[poe_portnummer] = poe_schaltwunsch;

		// Jetzt mssen wir nur noch das Schaltkommando zusammenbauen und senden
		sprintf(url,"http://%s/cgi/POE.cgi?",switch_ip);

		if (poe_port_on[ 1] != 0) strcat(url,"POE1=8&");
		if (poe_port_on[ 2] != 0) strcat(url,"POE1=4&");
		if (poe_port_on[ 3] != 0) strcat(url,"POE1=2&");
		if (poe_port_on[ 4] != 0) strcat(url,"POE1=1&");

		if (poe_port_on[ 5] != 0) strcat(url,"POE2=8&");
		if (poe_port_on[ 6] != 0) strcat(url,"POE2=4&");
		if (poe_port_on[ 7] != 0) strcat(url,"POE2=2&");
		if (poe_port_on[ 8] != 0) strcat(url,"POE2=1&");

		if (poe_port_on[ 9] != 0) strcat(url,"POE3=8&");
		if (poe_port_on[10] != 0) strcat(url,"POE3=4&");
		if (poe_port_on[11] != 0) strcat(url,"POE3=2&");
		if (poe_port_on[12] != 0) strcat(url,"POE3=1&");

		if (poe_port_on[13] != 0) strcat(url,"POE4=8&");
		if (poe_port_on[14] != 0) strcat(url,"POE4=4&");
		if (poe_port_on[15] != 0) strcat(url,"POE4=2&");
		if (poe_port_on[16] != 0) strcat(url,"POE4=1&");

		if (poe_port_on[17] != 0) strcat(url,"POE5=8&");
		if (poe_port_on[18] != 0) strcat(url,"POE5=4&");
		if (poe_port_on[19] != 0) strcat(url,"POE5=2&");
		if (poe_port_on[20] != 0) strcat(url,"POE5=1&");

		if (poe_port_on[21] != 0) strcat(url,"POE6=8&");
		if (poe_port_on[22] != 0) strcat(url,"POE6=4&");
		if (poe_port_on[23] != 0) strcat(url,"POE6=2&");
		if (poe_port_on[24] != 0) strcat(url,"POE6=1&");

		strcat(url,"update=Update");
		sprintf(kommando,"wget --cookies=on --load-cookies=/tmp/poecookie.txt --keep-session-cookies --save-cookies=/tmp/poecookie.txt \"%s\" -O %s --quiet",url,tmp_filename);
		// printf("Kommando: xxx%sxxx\n",kommando);

		sleep(1); // 1 Sekunde warten
		sprintf(k2,"rm %s 2>/dev/null",tmp_filename);
		system(k2);
		system(kommando);
		}



	// im Falle des Query-Reqests mu jetzt noch der Linkstatus ermittelt werden
	if (output_flag != 0)
		{
		sleep(1); // 1 Sekunde warten
		sprintf(url,"http://%s/PortSet.htm",switch_ip);
		sprintf(kommando,"wget --cookies=on --load-cookies=/tmp/poecookie.txt --keep-session-cookies --save-cookies=/tmp/poecookie.txt \"%s\" -O %s --quiet",url,tmp_filename);
		// printf("Kommando: xxx%sxxx\n",kommando);

		sprintf(k2,"rm %s 2>/dev/null",tmp_filename);
		system(k2);
		system(kommando);

		readfileinstring(tmp_filename,puffer);
		for (x = 1;x <= switch_number_of_ports;x++)
			{
			sprintf(tmpstr,"NOWRAP>%d</TD>",x);
			i = html_parse_string(puffer,tmpstr,"</TR>",buf2);
			if (i >= 0)
				{
				// printf("Buffer%d: \"%s\"\n",x,buf2);
				i = html_parse_string(buf2,"NOWRAP>","</TD>",buf1);
				// printf("BufLink: %s\n",buf1);
				if (strstr(buf1,"green.gif") != 0)
					{
					poe_port_linkup[x] = 1;
					for (i = 0;i < 40;i++)
						{
						buf2[i] = '#';
						}
					// printf("BufferB%d: \"%s\"\n",x,buf2);
					i = html_parse_string(buf2,"NOWRAP>","</TD>",buf1);
					// printf("BufSpeed%d: \"%s\"\n",x,buf1);
					if (strcmp(buf1,"100M") == 0) poe_port_linkspeed[x] = 100;
					if (strcmp(buf1,"10M") == 0) poe_port_linkspeed[x] = 10;
					}
				}
			}

		}



	// Falls Output gewnscht wurde, jetzt die Datei anlegen
	if (output_flag != 0)
		{
		f = fopen(output_filename,"wb");
		if (f == NULL)
			{
			printf("ERROR: could not open file \"%s\" for write.\n",output_filename);
			}
		else
			{
			fprintf(f,"<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\" ?>\n");
			fprintf(f,"<data>\n");
			fprintf(f,"<portcount>%ld</portcount>\n",switch_number_of_ports);
			for (x = 1;x <= switch_number_of_ports;x++)
				{
				fprintf(f,"<port%d>\n",x);
				fprintf(f,"   <poe_enabled>%d</poe_enabled>\n",poe_port_on[x]);
				fprintf(f,"   <poe_class>%d</poe_class>\n",poe_port_class[x]);
				fprintf(f,"   <poe_current>%d</poe_current>\n",poe_port_current[x]);
				fprintf(f,"   <link_up>%d</link_up>\n",poe_port_linkup[x]);
				fprintf(f,"   <link_speed>%d</link_speed>\n",poe_port_linkspeed[x]);
				fprintf(f,"</port%d>\n",x);
				}
			fprintf(f,"</data>\n");
			fclose(f);
			}
		}


	rw = 0;	
	return(rw);
	}

