// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   rgb_demon.c   -   Demon zum Steurn von 2 LED-Stripes und zur Abfrage von Potis und IR-Fernbedienung f. ALL3651**
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2009 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************

// **********   Eintrge in der Konfigurations-Datenbank, die vom Demon ausgewertet werden   **********
//
// /sys/network/udp_rx_port															UDP-Portnummer, auf die gelauscht wird
// /sys/network/udp_rx_username													zu bergebender Username
// /sys/network/udp_rx_password													zu bergebendes Pawort
// /control/rgb/var/rtc_day															Tag
// /control/rgb/var/rtc_weekday													Wochentag (0:Sonntag, 6:Samstag)
// /control/rgb/var/rtc_month														Monat
// /control/rgb/var/rtc_year														Jahr
// /control/rgb/var/rtc_hour														Stunde
// /control/rgb/var/rtc_minute													Minute
// /control/rgb/var/rtc_second													Sekunde
// /control/rgb/var/ti																	Hires-Timer
// /control/rgb/var/pot0																Wert von Poti 0
// /control/rgb/var/pot1																Wert von Poti 1
// /control/rgb/var/pot2																Wert von Poti 2
// /control/rgb/var/pot3																Wert von Poti 3
// /control/rgb/var/pot4																Wert von Poti 4
// /control/rgb/var/pot5																Wert von Poti 5
// /control/rgb/var/r0																	Rot 0
// /control/rgb/var/g0																	Grn 0
// /control/rgb/var/b0																	Blau 0
// /control/rgb/var/w0																	Wei 0
// /control/rgb/var/dim0																Dimspeed 0
// /control/rgb/var/r1																	Rot 1
// /control/rgb/var/g1																	Grn 1
// /control/rgb/var/b1																	Blau 1
// /control/rgb/var/w1																	Wei 1
// /control/rgb/var/dim1																Dimspeed 1
// /control/rgb/var/ir_decimal													zuletzt angekommener Tastencode von der IR-Fernbedienung (dezimal)
// /control/rgb/var/ir_ascii														zuletzt angekommener Tastencode (ASCII-Code)
// /control/rgb/var/ir_counter													Tastendruck-Zhler IR
// /control/rgb/var/last_control												Von welcher Quelle wurde der Controller zuletzt angesteuert ?
// /control/rgb/var/fw_major														Atmega8 Firmware Major-Version
// /control/rgb/var/fw_minor														Atmega8 Firmware Minor-Version
// /control/rgb/var/program_id													gerade geladenes Programm
// /control/rgb/var/program_status											Status des Programminterpreters
// /control/rgb/var/program_line												gerade abgearbeitete Programmzeile
// /control/rgb/var/program_delaycount									Stand des Programmzeilen-Delaycounters
// /control/rgb/timers/max_timers												Anzahl Timers maximal (blicherweise 32)
// /control/rgb/timers/timer<x>/enabled									Timer aktiv 0/1
// /control/rgb/timers/timer<x>/day											Schaltzeit Tag
// /control/rgb/timers/timer<x>/month										Monat
// /control/rgb/timers/timer<x>/year										Jahr
// /control/rgb/timers/timer<x>/hour										Schaltzeit Stunde
// /control/rgb/timers/timer<x>/minute									Minute
// /control/rgb/timers/timer<x>/monday									Schalten an Montagen
// /control/rgb/timers/timer<x>/tuesday									Schalten an Dienstagen
// /control/rgb/timers/timer<x>/wednesday								Schalten an Mittwochen
// /control/rgb/timers/timer<x>/thursday								Schalten an Donnerstagen
// /control/rgb/timers/timer<x>/friday									Schalten an Freitagen
// /control/rgb/timers/timer<x>/saturday								Schalten an Samstagen
// /control/rgb/timers/timer<x>/sunday									Schalten an Sonntagen
// /control/rgb/timers/timer<x>/name										Benennung
// /control/rgb/timers/timer<x>/descrition							Blatext
// /control/rgb/timers/timer<x>/program_id							Nummer des zu startenden Programms (-1 fr Stoppen)
// /control/rgb/plclients/max_clients										Maximale Anzahl Slave-Controller
// /control/rgb/plclients/netsync												Netsync ein/ausschalten 0/1
// /control/rgb/plclients/client<x>/ipaddress						IP-Adresse des Slaves
// /control/rgb/plclients/client<x>/port								zu verwendender UDP-Port
// /control/rgb/plclients/client<x>/username						Auth Username
// /control/rgb/plclients/client<x>/password						Auth Passwort
// /control/rgb/plclients/client<x>/enabled							Aktiv 0/1
// /control/rgb/programs/max_programs										Maximale Anzahl Programme
// /control/rgb/programs/program<x>/max_steps						Maximale Anzahl Zeilen in diesem Programm
// /control/rgb/programs/program<x>/name								Benennung des Programms
// /control/rgb/programs/program<x>/description					Blatext
// /control/rgb/programs/program<x>/step<y>/cmdtoken		Befehlstoken
// /control/rgb/programs/program<x>/step<y>/r0					Rot 0
// /control/rgb/programs/program<x>/step<y>/g0					Grn 0
// /control/rgb/programs/program<x>/step<y>/b0					Blau 0
// /control/rgb/programs/program<x>/step<y>/w0					Wei 0
// /control/rgb/programs/program<x>/step<y>/dim0				Dimspeed 0
// /control/rgb/programs/program<x>/step<y>/r1					Rot 1
// /control/rgb/programs/program<x>/step<y>/g1					Grn 1
// /control/rgb/programs/program<x>/step<y>/b1					Blau 1
// /control/rgb/programs/program<x>/step<y>/w1					Wei 1
// /control/rgb/programs/program<x>/step<y>/dim1				Dimspeed 1
// /control/rgb/programs/program<x>/step<y>/timer				Timer
// /control/rgb/bootdefault/r0													Startup
// /control/rgb/bootdefault/g0													Startup
// /control/rgb/bootdefault/b0													Startup
// /control/rgb/bootdefault/r1													Startup
// /control/rgb/bootdefault/g1													Startup
// /control/rgb/bootdefault/b1													Startup



#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <string.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <time.h>
#include <sys/time.h>
#include <sys/shm.h>
#include "at91gpio.h"
#include "all_i2c.h"
#include "i2c_chips.h"
#include "../sqlite/sqlite-3.7.3_arm/sqlite3.h"
#include "rgb_demon.h"
#include "sqldb.h"
#include "logging.h"
#include "shm_use.h"



// *****   Globale Variablen   *****

#define CONFIG_DATABASE_FILE "/etc/allnetenv/config.s3db"
#define VAR_DATABASE_FILE "/tmp/var.s3db"


unsigned long int	ti = 0;																// Zhler, geht bei jedem Durchlauf um 1 hoch
signed short int	programm_nummer = -1;									// Nummer des gerade aktiven Programms
signed short int	programm_az = -1;											// gerade abgearbeitete Zeilennummer
signed short int	programm_status = -1;									// Status (-2:muss geladen werden, -1:angehalten, 1: in Delay innerhalb der Zeile, 0:Zeile muss bearbeitet werden)
signed short int	programm_delaycounter = 0;						// Delayzhler innerhalb der Zeile
signed short int	programm_zeilennummer = -1;						// aktuelle Zeilennummer
signed short int	programm_max_steps = 16;							// Anzahl zulssiger Zeilennummern
signed short int	fernbedienung = -1;										// Typ der Fernbedienung (-1: Keine, 0: alte kleine FB mit altem Tiny85,
																												//                        1: PortaLuce FB mit neuem Tiny85,
																												//                        2: alte kleine FB mit neuem Tiny85)
signed short int	old_tiny_major = 0;										// IR-Empfnger Major ID
signed short int	old_tiny_minor = 0;										// IR-Empfnger Minor ID

struct programmzeile
	{
	signed short int 		cmdtoken;													// 0:NOP, 1:RGB_Set, 2:Restart 3:End
	signed short int		r0;
	signed short int		g0;
	signed short int		b0;
	signed short int		w0;
	signed short int		dim0;
	signed short int		r1;
	signed short int		g1;
	signed short int		b1;
	signed short int		w1;
	signed short int		dim1;
	signed short int		delay;
	signed short int		target;
	signed short int		switchtype;
	} pz;
struct programmzeile programm_zeile[101];


/*
// *****   Zufall - Ermitteln einer Zufallszahl zwischen 0...1   *****

	double Zufall() 
	{
	long x;
	long y;
	double rw;

	x = Wert_A * (Letzte_ZahlX & 65535) + (Letzte_ZahlX >> 16);
	y = Wert_B * (Letzte_ZahlY & 65535) + (Letzte_ZahlY >> 16);

	rw = (double)((x << 16) + (y & 65525));
	Letzte_ZahlX = x;
	Letzte_ZahlY = y;
	return (rw / 4294967296.0 + 0.5);
	}
*/


// *****   zufall_long - Ermitteln einer Zufallszahl zwischen 0...4294967295   *****

unsigned long int zufall_long() 
	{
	static long Wert_A = 26004;														// Random Seed A
	static long Wert_B = 26088;														// Random Seed B
	static long Letzte_ZahlX = 26004;											// old seed A
	static long Letzte_ZahlY = 26088;											// old seed B
	long x;
	long y;
	unsigned long int rw;

	x = Wert_A * (Letzte_ZahlX & 65535) + (Letzte_ZahlX >> 16);
	y = Wert_B * (Letzte_ZahlY & 65535) + (Letzte_ZahlY >> 16);

	rw = (x << 16) + (y & 65525);
	Letzte_ZahlX = x;
	Letzte_ZahlY = y;
	return (rw);
	}



// *****   sql_erase_rgbvalues   -   Lschen und Neuanlegen der Sensorwert- und anderer Tabellen in der Temp-DB   *****

void sql_erase_rgbvalues(sqlite3 *ptr)
	{
	char sql[255];

	do_sqlyy(ptr,"DROP TABLE [rgboutput];",0);
	do_sqlyy(ptr,"CREATE TABLE [rgboutput] ([id] INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,[r0] INTEGER NOT NULL,[g0] INTEGER NOT NULL,[b0] INTEGER NOT NULL,[w0] INTEGER NOT NULL,[d0] INTEGER NOT NULL,[r1] INTEGER NOT NULL,[g1] INTEGER NOT NULL,[b1] INTEGER NOT NULL,[w1] INTEGER NOT NULL,[d1] INTEGER NOT NULL);",0);
	sprintf(sql,"INSERT INTO rgboutput (id,r0,g0,b0,w0,d0,r1,g1,b1,w1,d1) VALUES (0,0,0,0,0,0,0,0,0,0,0);");
	// printf("SQL: \"%s\"\n",sql);
	do_sqlyy(ptr,sql,0);

	do_sqlyy(ptr,"DROP TABLE [potis];",0);
	do_sqlyy(ptr,"CREATE TABLE [potis] ([id] INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,[p0] INTEGER NOT NULL,[p1] INTEGER NOT NULL,[p2] INTEGER NOT NULL,[p3] INTEGER NOT NULL,[p4] INTEGER NOT NULL,[p5] INTEGER NOT NULL);",0);
	sprintf(sql,"INSERT INTO potis (id,p0,p1,p2,p3,p4,p5) VALUES (0,0,0,0,0,0,0);");
	do_sqlyy(ptr,sql,0);

	do_sqlyy(ptr,"DROP TABLE [temperatures];",0);
	do_sqlyy(ptr,"CREATE TABLE [temperatures] ([id] INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,[t_int] FLOAT NOT NULL,[t_ext] FLOAT NOT NULL,[h_ext] FLOAT NOT NULL);",0);
	sprintf(sql,"INSERT INTO temperatures (id,t_int,t_ext,h_ext) VALUES (0,-2048000.00,-2048000.00,-2048000.00);");
	do_sqlyy(ptr,sql,0);

	do_sqlyy(ptr,"DROP TABLE [ir];",0);
	do_sqlyy(ptr,"CREATE TABLE [ir] ([id] INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,[ir] INTEGER NOT NULL,[ircounter] INTEGER NOT NULL,[fw_major] INTEGER NOT NULL,[fw_minor] INTEGER NOT NULL,[tiny_major] INTEGER NOT NULL,[tiny_minor] INTEGER NOT NULL);",0);
	sprintf(sql,"INSERT INTO ir (id,ir,ircounter,fw_major,fw_minor,tiny_major,tiny_minor) VALUES (0,0,0,0,0,0,0);");
	do_sqlyy(ptr,sql,0);

	do_sqlyy(ptr,"DROP TABLE [program];",0);
	do_sqlyy(ptr,"CREATE TABLE [program] ([id] INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,[loaded_program] INTEGER NOT NULL,[running_line] INTEGER NOT NULL,[running_status] INTEGER NOT NULL,[new_program] INTEGER NOT NULL,[new_command]);",0);
	sprintf(sql,"INSERT INTO program (id,loaded_program,running_line,running_status,new_program,new_command) VALUES (0,0,0,0,0,0);");
	do_sqlyy(ptr,sql,0);
	}



// *****   sql_read_rgbvalues()   -   Daten aus der tmpDB holen   *****

signed short int sql_read_rgbvalues(sqlite3 *ptr,unsigned char *r0,unsigned char *g0,unsigned char *b0,unsigned char *w0,unsigned char *d0,unsigned char *r1,unsigned char *g1,unsigned char *b1,unsigned char *w1,unsigned char *d1)
	{
	signed short int rw = 0;
	sqlite3_stmt *vm;
	char *sql_query;
	signed short int i = 0;
	char zs[96];
	char sql[80] = "SELECT r0,g0,b0,w0,d0,r1,g1,b1,w1,d1 from rgboutput where id = 0;";


	// printf("rgb_demon%ld: read Start\n",ti);
beginn:
	//printf("SQL:\"%s\"\n",sql);
	sql_query = sqlite3_mprintf("%s",sql);								// Vorbereitung des SQL-Querys
	
	// Umwandlung des SQl Querys in Byte-code
	rw = sqlite3_prepare(ptr,sql_query,strlen(sql_query),&vm,NULL);
	if (rw != SQLITE_OK)
		{
		// printf("(Error %d bei \"%s\")\n",rw,sql);
		// printf("SQLITE Read lock problem !!!!!\n");
		sqlite3_finalize(vm);																// Loeschen des Statements
		sqlite3_free(sql_query);														// freigeben des Bytecodes
		usleep(25000);																			// 25 ms warten
		goto beginn;
		}

	// Ausgabe des Datensatzes
	while(sqlite3_step(vm) != SQLITE_DONE)
		{
		i++;
		if(sqlite3_column_text(vm,0) == NULL)
			{
			// printf("rgb_demon: sql_read_rgbvalues: NULL Pointer als Result bei \"%s\" - alte Werte werden beibehalten !\n",sql);
			rw = -1;
			goto final;
			}
		// printf("%s\n",sqlite3_column_text(vm,0));						// Inhalt des Datensatzes ausgeben
		strcpy(zs,(char *)sqlite3_column_text(vm,0));				// String aus dem DB-Recordset kopieren
		// printf("RW0:\"%s\"\n",zs);
		*r0 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,1));				// String aus dem DB-Recordset kopieren
		*g0 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,2));				// String aus dem DB-Recordset kopieren
		*b0 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,3));				// String aus dem DB-Recordset kopieren
		*w0 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,4));				// String aus dem DB-Recordset kopieren
		*d0 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,5));				// String aus dem DB-Recordset kopieren
		*r1 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,6));				// String aus dem DB-Recordset kopieren
		*g1 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,7));				// String aus dem DB-Recordset kopieren
		*b1 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,8));				// String aus dem DB-Recordset kopieren
		*w1 = atol(zs);
		strcpy(zs,(char *)sqlite3_column_text(vm,9));				// String aus dem DB-Recordset kopieren
		*d1 = atol(zs);
		rw = 1;
		}
	if(i < 1)																							// wenn kein Datensatz, -1 zurckgeben
		{
		printf("rgb_demon: sql_read_rgbvalues: kein Datensatz - alte Werte werden beibehalten !\n");
		rw = 0;
		}

final:
	sqlite3_finalize(vm);																	// Loeschen des Statements
	sqlite3_free(sql_query);															// freigeben des Bytecodes
	// printf("rgb_demon: read End\n");
	return(rw);
	}



// *****   sql_write_rgbvalues   -   Schreiben der RGB-Output-Werte in die tmpDB   *****

void sql_write_rgbvalues(sqlite3 *ptr,unsigned char r0,unsigned char g0,unsigned char b0,unsigned char w0,unsigned char d0,unsigned char r1,unsigned char g1,unsigned char b1,unsigned char w1,unsigned char d1)
	{
	char sql[255];

	// printf("rgb_demon: write Start\n");
	sprintf(sql,"UPDATE rgboutput SET r0=%d,g0=%d,b0=%d,w0=%d,d0=%d,r1=%d,g1=%d,b1=%d,w1=%d,d1=%d WHERE id = 0;",r0,g0,b0,w0,d0,r1,g1,b1,w1,d1);
	// printf("SQL: \"%s\"\n",sql);
	do_sqlyy(ptr,sql,0);
	// printf("rgb_demon: write End\n");
	}



// *****   sql_write_potivalues   -   Schreiben der Potentiometer-Mewerte in die tmpDB   *****

void sql_write_potivalues(sqlite3 *ptr,unsigned char poti0,unsigned char poti1,unsigned char poti2,unsigned char poti3,unsigned char poti4,unsigned char poti5)
	{
	char sql[255];

	sprintf(sql,"UPDATE potis SET p0=%d,p1=%d,p2=%d,p3=%d,p4=%d,p5=%d WHERE id = 0;",poti0,poti1,poti2,poti3,poti4,poti5);
	// printf("SQL: \"%s\"\n",sql);
	do_sqlyy(ptr,sql,0);
	}



// *****   sql_write_ir_fwversion   -   Schreiben der Atmel-Firmwareversionen (Atmega8 und Attiny85) in die tmpDB   *****

void sql_write_ir_fwversion(sqlite3 *ptr,unsigned char fw_major,unsigned fw_minor,unsigned char tiny_major,unsigned char tiny_minor)
	{
	char sql[255];

	sprintf(sql,"UPDATE [ir] SET [fw_major]=%d,[fw_minor]=%d,[tiny_major]=%d,[tiny_minor]=%d WHERE [id] = 0;",
					fw_major,fw_minor,tiny_major,tiny_minor);
	// printf("SQL: \"%s\"\n",sql);
	do_sqlyy(ptr,sql,0);
	}



// *****   sql_write_ir_keypress   -   Schreiben der Fernbedienungs-Signale in die tmpDB   *****

void sql_write_ir_keypress(sqlite3 *ptr,unsigned char ir,unsigned long int ircounter)
	{
	char sql[255];

	sprintf(sql,"UPDATE [ir] SET [ir]=%d,[ircounter]=%ld WHERE [id] = 0;",
					ir,ircounter);
	// printf("SQL: \"%s\"\n",sql);
	do_sqlyy(ptr,sql,0);
	}



// *****   sql_write_temperatures   -   Schreiben der Temperatur-Mewerte in die tmpDB   *****

void sql_write_temperatures(sqlite3 *ptr,double t_int,double t_ext,double h_ext)
	{
	char sql[255];

	sprintf(sql,"UPDATE temperatures SET t_int=%1.2f,t_ext=%1.2f,h_ext=%1.2f WHERE id = 0;",t_int,t_ext,h_ext);
	// printf("SQL: \"%s\"\n",sql);
	do_sqlyy(ptr,sql,0);
	}



// *****   Blinken   *****

void blinke(unsigned char kanaele)
	{
	unsigned short int w = 1000;
	unsigned char d = 0;
	unsigned char h = 50;

	if(kanaele == 1)
			{
			rgb_set(d,d,d,d,t_r1,t_g1,t_b1,t_w1,0,0);
			usleep(w);
			rgb_set(h,h,h,h,t_r1,t_g1,t_b1,t_w1,0,0);
			usleep(w);
			}
	if(kanaele == 2)
			{
			rgb_set(t_r0,t_g0,t_b0,t_w0,d,d,d,d,0,0);
			usleep(w);
			rgb_set(t_r0,t_g0,t_b0,t_w0,h,h,h,h,0,0);
			usleep(w);
			}
	if(kanaele == 3)
			{
			rgb_set(d,d,d,d,d,d,d,d,0,0);
			usleep(w);
			rgb_set(h,h,h,h,h,h,h,h,0,0);
			usleep(w);
			}

	rgb_set(t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);
	usleep(w);
	rgb_set(t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,t_dim0,t_dim1);
	}



// *****   Schreiben von Werten   *****

unsigned char rgb_set(unsigned char r0,unsigned char g0,unsigned char b0,unsigned char w0,unsigned char r1,unsigned char g1,unsigned char b1,unsigned char w1,unsigned char dim0,unsigned char dim1)
	{
	unsigned char rw;
	unsigned char retries;
	unsigned char t;
	static signed short int last_r0 = -1;
	static signed short int last_g0 = -1;
	static signed short int last_b0 = -1;
	static signed short int last_w0 = -1;
	static signed short int last_d0 = -1;
	static signed short int last_r1 = -1;
	static signed short int last_g1 = -1;
	static signed short int last_b1 = -1;
	static signed short int last_w1 = -1;
	static signed short int last_d1 = -1;


	if ((last_r0 == r0) && (last_g0 == g0) && (last_b0 == b0) && (last_w0 == w0) && (last_d0 == dim0)
	  &&(last_r1 == r1) && (last_g1 == g1) && (last_b1 == b1) && (last_w1 == w1) && (last_d1 == dim1))
		{
		// printf("nosend\n");
		rw = 2;
		goto ende;
		}

	for(retries = 0;retries < 5;retries++)
		{
		if (retries > 0) usleep(10000);											// 10 ms warten
		t = all_i2c_chip_dualrgb_write(0,90,r0,g0,b0,w0,r1,g1,b1,w1,dim0,dim1);
		if (t == 0) goto okidoki;
		// printf("RGBwrite Error (Try %d): %d\n",retries,t);
		}
	rw = 1;
	goto ende;

okidoki:
	rw = 0;
	last_r0 = r0;
	last_g0 = g0;
	last_b0 = b0;
	last_w0 = w0;
	last_d0 = dim0;
	last_r1 = r1;
	last_g1 = g1;
	last_b1 = b1;
	last_w1 = w1;
	last_d1 = dim1;

ende:
	// printf("%d = all_i2c_chip_dualrgb_write(0,3,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d)\n",rw,r0,g0,b0,w0,r1,g1,b1,w1,dim0,dim1);
	return(rw);
	}



// *****   Lesen von Werten   *****

unsigned char rgb_read()
	{
	unsigned char rw;

	rw = all_i2c_chip_dualrgb_read(0,90);
	return(rw);
	}



// *****   Lesen der Temperatur   *****

double temp_read()
	{
	double rw;

	rw = simplified_lm75_read_temp(2,0,0,30,0);

	// t_temperature_ext = simplified_lm92_read_temp(0,0,0,3,3);
	t_humidity_ext = simplified_sht71_read_humidity(0,0,0,30);
	t_temperature_ext = simplified_sht71_read_temp(0,0,0,30);

	return(rw);
	}


// *****   udp_send() - Daten senden   *****

void udp_send(char zielip[],unsigned short int portnummer,unsigned char *daten,unsigned short int laenge)
	{
	int							udp_socket;
	struct					sockaddr_in steuerstruct;

	// printf("udp_send an %s:%d, %d Bytes.\n",zielip,portnummer,laenge);

	if ((udp_socket = socket(PF_INET,SOCK_DGRAM,IPPROTO_UDP)) >= 0) // UDP-Socket anlegen
		{
		// Construct the server sockaddr_in structure
		memset(&steuerstruct,0,sizeof(steuerstruct));				// Struct auf 0 setzen
		steuerstruct.sin_family = AF_INET;									// Internet/IP
		steuerstruct.sin_addr.s_addr = inet_addr(zielip);		// IP-Addresse
		steuerstruct.sin_port = htons(portnummer);					// UDP-Portnummer

		sendto(udp_socket,daten,laenge,0,(struct sockaddr *) &steuerstruct,sizeof(steuerstruct));
		close(udp_socket);
		// printf("OK.\n");
		}

	}



// *****   Hauptschleife   *****

int main(int argc,char **argv)
	{
	unsigned char 	old_r0 = 0;
	unsigned char 	old_g0 = 0;
	unsigned char 	old_b0 = 0;
	unsigned char 	old_w0 = 0;
	unsigned char 	old_r1 = 0;
	unsigned char 	old_g1 = 0;
	unsigned char 	old_b1 = 0;
	unsigned char 	old_w1 = 0;
	unsigned char 	old_poti0 = 0;
	unsigned char 	old_poti1 = 0;
	unsigned char 	old_poti2 = 0;
	unsigned char 	old_poti3 = 0;
	unsigned char 	old_poti4 = 0;
	unsigned char 	old_poti5 = 0;
	unsigned char 	old_fw_major = 0;
	unsigned char 	old_fw_minor = 0;
	unsigned char 	old_ir = 27;
	unsigned char 	old_ircounter = 0;
	unsigned char 	old_dim0 = 254;
	unsigned char 	old_dim1 = 255;
	unsigned char		old_last_control = 255;
	double					old_temperature_int = -2048000;
	double					old_temperature_ext = -2048000;
	double					old_humidity_ext = -2048000;
	unsigned char		t = 0;
	unsigned char		retries;
	unsigned char		max_retries = 5;
	signed long int	i;
	unsigned char		last_control = 0;
	char						tmpstring[80];
	unsigned long		az = 0;																// nderungszhler RGBW + Dim
	unsigned long		az_potis = 0;													// nderungszhler Potis
	unsigned long		az_ir = 0;														// nderungszhler IR-Fernbedienung
	unsigned long		az_tiny = 0;													// nderungszhler ATTINY-Versionsnummer / ATmega8 Versionsnummer
	unsigned short int j;
	unsigned short int l;
	unsigned char		k[50];
	unsigned char		c;
	char lstring[255];																		// Puffer fr Logging
	signed short int enable_netsync = 0;									// ein/Ausschalten von Netsync
	unsigned short int netsync_maxclients = 10;						// Anzahl Slaves
	unsigned short int netsync_slave_udpport[100];				// UDP Port
	char						netsync_slave_ip[100][30];						// IP-Adresse
	char						netsync_slave_username[100][30];			// Username
	char						netsync_slave_password[100][30];			// Passwort
	signed short int netsync_slave_enabled[100];					// Slave Aktiv
	signed short int netsync_slave_counter = 0;						// Anzahl aktiver Slaves
	unsigned char temperature_counter = 0;								// Zhler fr Temperaturmessungen
	char ep[1024];																				// Puffer fr Logfile-Meldungen
	unsigned char		tiny_major = 0;
	unsigned char		tiny_minor = 0;
	unsigned char		tiny_vlock = 0;
	unsigned char		tmp_tinymajor = 0;
	unsigned char		tmp_tinyminor = 0;



	// auf existierendes Shared Memory fr Demonstatus zugreifen
	if (use_my_demonstatus_shm(1) != 1) goto errorende;		// MY_DEMON_ID = 1: rgb_demon

	// Status von Demon in SHM eintragen
	my_demonstatus_data[my_demon_id].demon_id = my_demon_id;														// 0 ist Default, hier wird die eigene ID eingetragen
	sprintf(my_demonstatus_data[my_demon_id].name_string,"rgb_demon");									// Name
	sprintf(my_demonstatus_data[my_demon_id].version_string,"%s",RGBDEMON_VERSION);			// Versionsnummer
	my_demonstatus_data[my_demon_id].last_boot = time(0);																// Timestamp(UTC) des Starts
	my_demonstatus_data[my_demon_id].last_activity = time(0);														// Timestamp(UTC) der letzten Aktion
	my_demonstatus_data[my_demon_id].ti = ti;																						// Counter
	sprintf(my_demonstatus_data[my_demon_id].debug_message,"Start");										// letzte Debug-Meldung
	my_demonstatus_data[my_demon_id].error_message[0] = 0;															// letzte Fehlermeldung
	my_demonstatus_data[my_demon_id].status_long = 0;																		// numerischer Status
	sprintf(my_demonstatus_data[my_demon_id].status_string,"startup");									// String-Status


	// Logging-System initialisieren
	strcpy (log_filename,"/www/reports/rgb_demon.log");		// Logfilenamen setzen
	log_level = 2;																				// Debuglevel setzen
	log_kill();																						// Logfile loeschen
	sprintf(ep,"----------   rgb_demon V %s started (debuglevel=%d)   ----------",RGBDEMON_VERSION,log_level);
	log_append(1,ep);																			// Startmeldung ins Logfile schreiben


	gpio_devmem_open();																		// I/O-Memory-Filehandles initialiseren
	i2c_ruhe(0);																					// Ruhe am Bus0 (Initialisierung auf Standardwerte)

	gpio_port_init_output(PORT_A,26);											// I2C Clock ist Ausgang
	gpio_port_init_output(PORT_D,29);											// I2C DATA ist Ausgang
	gpio_port_write(PORT_A,26,1);													// Bus2 SCL liegt auf PA26
	gpio_port_write(PORT_D,29,1);													// Bus2 SDA liegt auf PD29

	gpio_port_init_output(PORT_B,20);											// Meldeeingang vom ATMEGA8
	gpio_port_write(PORT_B,20,1);													// PB20
	gpio_port_init_input(PORT_B,20);											// auf Eingang setzen

	gpio_port_init_output(PORT_B,21);											// /Inhibit-Ausgang zum ATMEGA8
	gpio_port_write(PORT_B,21,1);													// PB21, auf H setzen


	sqlite3_open(VAR_DATABASE_FILE,&sql_var_handle);			// SQLITE3-Datenbank ffnen
	sql_erase_rgbvalues(sql_var_handle);									// tmp-DB anlegen

	// Einstellungen fr lokalen RGB-Demon
	// udp_rx_port = sqldb_read_long("/sys/network/udp_rx_port");
	// sqldb_read_string("/sys/network/udp_rx_username",udp_rx_username);
	// sqldb_read_string("/sys/network/udp_rx_password",udp_rx_password);

	// Einstellungen fr die Fernbedienung
	fernbedienung = sqldb_read_long("/control/rgb/remotecontrol/type");

	// Einstellungen fr Netsync ber UDP
	enable_netsync = sqldb_read_long("/control/rgb/plclients/enablenetsync");
	if (enable_netsync > 0)
		{
		netsync_slave_counter = 0;
		netsync_maxclients = sqldb_read_long("/control/rgb/plclients/max_clients");
		for(t = 0;t < netsync_maxclients;t++)
			{
			sprintf(tmpstring,"/control/rgb/plclients/client%d/enabled",t);
			i = sqldb_read_long(tmpstring);
			if (i > 0)
				{
				netsync_slave_enabled[netsync_slave_counter] = 1;
				sprintf(tmpstring,"/control/rgb/plclients/client%d/port",t);					netsync_slave_udpport[netsync_slave_counter] = sqldb_read_long(tmpstring);
				sprintf(tmpstring,"/control/rgb/plclients/client%d/ipaddress",t);			sqldb_read_string(tmpstring,netsync_slave_ip[netsync_slave_counter]);
				sprintf(tmpstring,"/control/rgb/plclients/client%d/username",t);			sqldb_read_string(tmpstring,netsync_slave_username[netsync_slave_counter]);
				sprintf(tmpstring,"/control/rgb/plclients/client%d/password",t);			sqldb_read_string(tmpstring,netsync_slave_password[netsync_slave_counter]);
				netsync_slave_counter++;
				}
			}
		}
	if (netsync_slave_counter < 1) enable_netsync = 0;


	// printf("PB20 Status:%d\n",gpio_port_read(PORT_B,20));
	// Start loggen
	sprintf(lstring,"**********   RGB demon V %s started   **********",RGBDEMON_VERSION);
	log_append(1,lstring);
	sprintf(lstring,"FB_Type:%d",fernbedienung);
	log_append(1,lstring);


	printf("RGB demon V %s started. ",RGBDEMON_VERSION);
	printf("Netsync:%d (%d Clients)\n",enable_netsync,netsync_slave_counter);

	printf("Resetting ATMEGA8 Dimmer controller...\n");
	log_append(1,"Resetting ATMEGA8 Dimmer controller");
	gpio_port_init_output(PORT_B,31);										// ATMEGA8 Reset
	gpio_port_write(PORT_B,31,1);												// Reset auslsen
	usleep(300000);																			// 0.2 Sekunden warten
	gpio_port_write(PORT_B,31,0);												// Leitung wieder nach +5V hochschnalzen lassen
	usleep(500000);																			// 0.5 Sekunden warten

	t_r0 = sqldb_read_long("/control/rgb/bootdefault/r0");
	t_g0 = sqldb_read_long("/control/rgb/bootdefault/g0");
	t_b0 = sqldb_read_long("/control/rgb/bootdefault/b0");
	t_w0 = sqldb_read_long("/control/rgb/bootdefault/w0");
	t_r1 = sqldb_read_long("/control/rgb/bootdefault/r1");
	t_g1 = sqldb_read_long("/control/rgb/bootdefault/g1");
	t_b1 = sqldb_read_long("/control/rgb/bootdefault/b1");
	t_w1 = sqldb_read_long("/control/rgb/bootdefault/w1");
	sql_write_rgbvalues(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_dim0,t_r1,t_g1,t_b1,t_w1,t_dim1);

	printf("Bootdefault RGBW: %d %d %d %d  %d %d %d %d\n",t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1);
	for(retries = 0;retries < max_retries;retries++)
		{
		t = rgb_set(t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,0,0);// Neue Werte schreiben
		if (t == 0) goto weiterboot;
		printf("RGB_write Write Error (Try %d)\n",retries);
		usleep(10000);																		// 10 ms warten
		}
weiterboot:
	log_append(1,"done. Ready to work.");



	sprintf(my_demonstatus_data[my_demon_id].debug_message,"running");									// letzte Debug-Meldung
hauptschleife:
	update_demonstatus(ti,1,"main loop");									// Status von Demon in SHM aktualisieren

	i = 0;
	usleep(1000);																					// 1 ms warten
	zufall_long();																				// Zufall immer schn mitlaufen lassen
	ti++;																									// Schleifenzhler erhhen
	// printf("ti=%ld\n",ti);

	// ----- RGB-Werte aus der tmpDB lesen -----
	update_demonstatus(ti,2,"RGB read");									// Status von Demon in SHM aktualisieren
reread:
	t = sql_read_rgbvalues(sql_var_handle,&t_r0,&t_g0,&t_b0,&t_w0,&t_dim0,&t_r1,&t_g1,&t_b1,&t_w1,&t_dim1);
	// printf("R0:%d,G0:%d,B0:%d,W0:%d,  R1:%d,G1:%d,B1:%d,W1:%d\n",t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1);
	if (t != 1)
		{
		i++;
		if (i > 10)
			{
			printf("rgb_demon: kann keine RGB-Werte aus der tmp-DB lesen (Errorcode: %d)\n",t);
			i = 0;
			}
		usleep(20000);																			// 20 ms warten
		goto reread;																				// und es dann wieder probieren
		}

	// ----- Werte vom Atmega8 holen  -----
	update_demonstatus(ti,3,"ATMEGA8 read");							// Status von Demon in SHM aktualisieren
// reread:
	if(gpio_port_read(PORT_B,20) != 0)
		{
		for(retries = 0;retries < max_retries;retries++)
			{
			// printf("%ld: ATMEGA8_Read Start\n",ti);
			t = rgb_read();
			usleep(1000);																					// 1 ms warten
			if (t == 0) goto weiter0;
			}
		sprintf(lstring,"*** ERROR: RGB Read Error even after %d retries.",max_retries);
		printf("%s\n",lstring);
		log_append(2,lstring);
		goto hauptschleife;
weiter0:
		sprintf(lstring,"(Control_Debug) Input from ATMEGA8 by IRQ: r0:%d,g0:%d,b0:%d,w0:%d r1:%d,g1:%d,b1:%d,w1:%d IR:%d,IRcount:%d, P0:%d,P1:%d,P2:%d,P3:%d,P4:%d,P5:%d",t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,t_ir,t_ircounter,t_poti0,t_poti1,t_poti2,t_poti3,t_poti4,t_poti5);
		log_append(4,lstring);
		// printf("%ld: ATMEGA8_Read ende\n",ti);
		}




	// ----- Wenn an den Potis gedreht wurde, dann die RGB-Werte nach Potivorgaben setzen -----
	// Poti-Kram soll in zukunft ber einen eigenen Poti-Dmon laufen - dann kann man mappen, Schalter setzen usw.

	/*
	poti_summe = (unsigned short int)t_poti0 + (unsigned short int)t_poti1 + (unsigned short int)t_poti2 + (unsigned short int)t_poti3 + (unsigned short int)t_poti4 + (unsigned short int)t_poti5;
	if (poti_summe > poti_summe_old)
		{
		poti_differenz = poti_summe - poti_summe_old;
		}
	else
		{
		poti_differenz = poti_summe_old - poti_summe;
		}
	if (poti_differenz > 2)
		{
		poti_summe_old = poti_summe;												// Summe der Potis merken
		t_r0 = t_poti0;																			// RGB-Farben nach Potis setzen
		t_g0 = t_poti1;
		t_b0 = t_poti2;
		t_r1 = t_poti3;
		t_g1 = t_poti4;
		t_b1 = t_poti5;
		}
	*/


	// -----   IR-Fernbedienungstaste gedrckt ? Dann die Taste ggfs. in die tmp-DB Table [ir] schreiben   -----
	update_demonstatus(ti,4,"IR read");										// Status von Demon in SHM aktualisieren
	if (t_ircounter != old_ircounter)
		{
		old_ircounter = t_ircounter;

		// printf("** Taste mit Code %d gedrckt **\n",t_ir);
		if (fernbedienung < 0) goto ignore_ir_remote;				// -1 ignoriert alles, was da reinkommt

		if (tiny_vlock > 0)																			// Versions-Lock
			{
			if(tiny_vlock == 1)
				{
				tmp_tinymajor = t_ir;
				// printf("tmpTinyMajor = %d\n",tmp_tinymajor);
				tiny_vlock++;
				goto ignore_ir_remote;
				}
			if(tiny_vlock == 2)
				{
				tmp_tinyminor = t_ir;
				// printf("tmpTinyMinor = %d\n",tmp_tinyminor);
				tiny_vlock++;
				goto ignore_ir_remote;
				}
			if(tiny_vlock >= 3)
				{
				if (t_ir == 255)
					{
					tiny_minor = tmp_tinyminor;
					tiny_major = tmp_tinymajor;
					// printf("ATTiny Version: = %d.%02d\n",tiny_major,tiny_minor);
					tiny_vlock = 0;
					goto ignore_ir_remote;
					}
				else
					{
					// printf("Error, Vlock Mode disabled.\n");
					tiny_vlock = 0;
					goto ignore_ir_remote;
					}
				}
			}
		
		if(t_ir == 1)																				// 1 ist der Header fr ein Versions-Datenpaket
			{
			// printf("V-Paket erkannt !\n");
			tiny_vlock = 1;
			goto ignore_ir_remote;
			}
		if(t_ir == 255)																			// 255 ist der Footer fr ein Versions-Datenpaket
			{
			// printf("V-Paketende erkannt, Vmode deaktiviert !\n");
			tiny_vlock = 0;
			goto ignore_ir_remote;
			}

		programm_status = -1;																// Programm stoppen
		do_sqlyy(sql_var_handle,"UPDATE [program] SET [new_command]=-2 WHERE [id] = 0;",0);

		// printf("rgb_demon: ir_count:%d, IR_KEY:%d\n",t_ircounter,t_ir);
		sql_write_ir_keypress(sql_var_handle,t_ir,t_ircounter); // IR-Tastendruck speichern
		}

ignore_ir_remote:



	// ----- Prfen, ob sich gegenber dem letztenmal etwas gendert hat -----
	az = 0;
	if (old_r0				!= t_r0				) az++;
	if (old_g0				!= t_g0				) az++;
	if (old_b0				!= t_b0				) az++;
	if (old_w0				!= t_w0				) az++;
	if (old_r1				!= t_r1				) az++;
	if (old_g1				!= t_g1				) az++;
	if (old_b1				!= t_b1				) az++;
	if (old_w1				!= t_w1				) az++;
	if (old_dim0			!= t_dim0			) az++;
	if (old_dim1			!= t_dim1			) az++;

	az_potis = 0;
	if (old_poti0			!= t_poti0		) az_potis++;
	if (old_poti1			!= t_poti1		) az_potis++;
	if (old_poti2			!= t_poti2		) az_potis++;	
	if (old_poti3			!= t_poti3		) az_potis++;
	if (old_poti4			!= t_poti4		) az_potis++;
	if (old_poti5			!= t_poti5		) az_potis++;	

	az_ir = 0;
	if (old_ir				!= t_ir				) az_ir++;
	if (old_ircounter	!= t_ircounter) az_ir++;
	
	az_tiny = 0;
	if (old_fw_major	!= t_fw_major	) az_tiny++;	
	if (old_fw_minor	!= t_fw_minor	) az_tiny++;	
	if (old_tiny_major!= tiny_major	) az_tiny++;
	if (old_tiny_minor!= tiny_minor	) az_tiny++;



	// ----- Werte ber das LAN per UDP an andere Clients propagieren, falls erforderlich -----
	if (az > 0)
		{
		if (enable_netsync > 0)
			{
			update_demonstatus(ti,5,"Netsync");								// Status von Demon in SHM aktualisieren
	 		if (az > 0)
				{
				for(t = 0;t < netsync_maxclients;t++)
					{
					// Jetzt mssen die aktivierten Clients angesprochen werden
					// printf("%ld: Demon -> Client %s\n",ti,plclient_node_ip[t]);
					for(j = 0;j < 48;j++)
						{
						k[j] = 0;
						}

					l = 0;
					for(j = 0;j < 20;j++)
						{
						c = netsync_slave_username[t][j];
						if (c == 0) goto skip1;
						k[++l] = c;
						}
skip1:
					l = 20;
					for(j = 0;j < 20;j++)
						{
						c = netsync_slave_password[t][j];
						if (c == 0) goto skip2;
						k[++l] = c;
						}
skip2:
					k[40] = t_r0;
					k[41] = t_g0;
					k[42] = t_b0;
					k[43] = t_w0;
					k[44] = t_dim0;
					k[45] = t_r1;
					k[46] = t_g1;
					k[47] = t_b1;
					k[48] = t_w1;
					k[49] = t_dim1;

					udp_send(netsync_slave_ip[t],netsync_slave_udpport[t],k,50);
					}
				}
			}
		}

	// ----- Werte in den Atmega8 schreiben -----
	if (az > 0)
		{
		update_demonstatus(ti,6,"ATMEGA8 write");						// Status von Demon in SHM aktualisieren
		// printf("%ld: ATMEGA8_Write Start\n",ti);
		// printf("Atmega8 RGB_set %d %d %d %d  %d %d %d $d  %d %d\n",t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,t_dim0,t_dim1);
		for(retries = 0;retries < max_retries;retries++)
			{
			t = rgb_set(t_r0,t_g0,t_b0,t_w0,t_r1,t_g1,t_b1,t_w1,t_dim0,t_dim1);// Neue Werte schreiben
			if (t == 2) goto weiter;
			if (t == 0) goto weiter;
			// printf("RGB_write Write Error (Try %d)\n",retries);
			usleep(25000);																		// 25 ms warten
			}
		sprintf(lstring,"rgb_demon: RGB Write Error even after %d retries.",max_retries);
		printf("%s\n",lstring);
		log_append(3,lstring);
		goto hauptschleife;

weiter:
		usleep(15000);																			// 15 ms warten
		// printf("%ld: ATMEGA8_Write end\n",ti);
		}


	// Gertetemparatur vom integrierten LM75 auslesen
	// und auch ggfs. von einem externen SHT71 Temp. und Feuchte holen
	// aber nur bei jedem 120. Durchlauf, um die Systemantwortzeiten nicht unntig hochzutreiben
	temperature_counter++;
	if (temperature_counter > 120)
		{
		update_demonstatus(ti,7,"Temp. read");							// Status von Demon in SHM aktualisieren
		temperature_counter = 0;
		t_temperature_int = temp_read();
		}

	// Prfen, ob an den Potis gedreht wurde oder ein IR-Kommando kam
	if (az_potis > 0) last_control = 2;
	if (az_ir > 0) last_control = 3;


	// Poti-Werte in die TMP-DB schreiben
	if (az_potis > 0)
		{
		update_demonstatus(ti,8,"CV write");								// Status von Demon in SHM aktualisieren
		// printf("Potiwerte gendert...");
		sql_write_potivalues(sql_var_handle,t_poti0,t_poti1,t_poti2,t_poti3,t_poti4,t_poti5);
		// printf("OK\n");
		}

	if ((t_r0 != old_r0) || (t_g0 != old_g0) || (t_b0 != old_b0) || (t_w0 != old_w0) || (t_dim0 != old_dim0) 
	 || (t_r1 != old_r1) || (t_g1 != old_g1) || (t_b1 != old_b1) || (t_w1 != old_w1) || (t_dim1 != old_dim1))
		{
		// sql_write_rgbvalues(sql_var_handle,t_r0,t_g0,t_b0,t_w0,t_dim0,t_r1,t_g1,t_b1,t_w1,t_dim1);
		} 

	if (az_tiny > 0)
		{
		update_demonstatus(ti,9,"FWV write");								// Status von Demon in SHM aktualisieren
		sql_write_ir_fwversion(sql_var_handle,t_fw_major,t_fw_minor,tiny_major,tiny_minor);
		}

	// gemessene Temperaturwerte in Temp-DB schreiben
	if ((t_temperature_int != old_temperature_int) || (t_temperature_ext != old_temperature_ext) || (t_humidity_ext != old_humidity_ext))
		{
		update_demonstatus(ti,10,"Temp. write");						// Status von Demon in SHM aktualisieren
		sql_write_temperatures(sql_var_handle,t_temperature_int,t_temperature_ext,t_humidity_ext);
		}


	// Alte Werte merken
	old_r0 = t_r0;
	old_g0 = t_g0;
	old_b0 = t_b0;
	old_w0 = t_w0;
	old_r1 = t_r1;
	old_g1 = t_g1;
	old_b1 = t_b1;
	old_w1 = t_w1;
	old_poti0 = t_poti0;	
	old_poti1 = t_poti1;	
	old_poti2 = t_poti2;	
	old_poti3 = t_poti3;	
	old_poti4 = t_poti4;	
	old_poti5 = t_poti5;	
	old_fw_major = t_fw_major;	
	old_fw_minor = t_fw_minor;	
	old_ir = t_ir;
	old_ircounter = t_ircounter;
	old_dim0 = t_dim0;
	old_dim1 = t_dim1;
	old_last_control = last_control;
	old_temperature_int = t_temperature_int;
	old_temperature_ext = t_temperature_ext;
	old_humidity_ext = t_humidity_ext;
	old_tiny_major = tiny_major;
	old_tiny_minor = tiny_minor;

	goto hauptschleife;


errorende:
// ende:
	sqlite3_close(sql_var_handle);												// Datenbank schlieen
	return(0);
	}
