// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   rgb_out.c   -   ALL3651 Leuchtensteuerungs-Commandlinetool                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2011 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************



#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <fcntl.h>
#include "../sqlite/sqlite-3.7.3_arm/sqlite3.h"
#include "sqldb.h"


// #define CONFIG_DATABASE_FILE "/etc/allnetenv/config.s3db"
#define VAR_DATABASE_FILE "/tmp/var.s3db"

sqlite3								*sql_var_handle;																							// Handle fr die DB



// *****   print_usage() - Bedienungsanleitung ausgeben   *****

void print_usage()
	{
	printf("USAGE: rgb_out red0 green0 blue0 white0 dim0 red1 green1 blue1 white1 dim1\n");
	exit(0);
	}



// *****   sql_write_rgbvalues   -   Schreiben der RGB-Output-Werte in die tmpDB   *****

void sql_write_rgbvalues(sqlite3 *ptr,unsigned char r0,unsigned char g0,unsigned char b0,unsigned char w0,unsigned char d0,unsigned char r1,unsigned char g1,unsigned char b1,unsigned char w1,unsigned char d1)
	{
	char sql[255];

	sprintf(sql,"UPDATE rgboutput SET r0=%d,g0=%d,b0=%d,w0=%d,d0=%d,r1=%d,g1=%d,b1=%d,w1=%d,d1=%d WHERE id = 0;",r0,g0,b0,w0,d0,r1,g1,b1,w1,d1);
	// printf("SQL: \"%s\"\n",sql);
	do_sqlyy(ptr,sql,0);
	}



// *****   Hauptprogramm   *****

int main(int argc,char **argv)
	{
	unsigned char r0;
	unsigned char g0;
	unsigned char b0;
	unsigned char w0;
	unsigned char d0;
	unsigned char r1;
	unsigned char g1;
	unsigned char b1;
	unsigned char w1;
	unsigned char d1;



 	if (argc != 11)
		{
		print_usage();
		}
  	
 	r0 = atoi(argv[1]);
 	g0 = atoi(argv[2]);
 	b0 = atoi(argv[3]);
 	w0 = atoi(argv[4]);
 	d0 = atoi(argv[5]);
 	r1 = atoi(argv[6]);
 	g1 = atoi(argv[7]);
 	b1 = atoi(argv[8]);
 	w1 = atoi(argv[9]);
 	d1 = atoi(argv[10]);

	printf("rgb_out(R0:%d,G0:%d,B0:%d,W0:%d,D0:%d  R1:%d,G1:%d,B1:%d,W1:%d,D1:%d)\n",r0,g0,b0,w0,d0,r1,g1,b1,w1,d1);

	sqlite3_open(VAR_DATABASE_FILE,&sql_var_handle);			// SQLITE3-Datenbank ffnen
	sql_write_rgbvalues(sql_var_handle,r0,g0,b0,w0,d0,r1,g1,b1,w1,d1);
	sqlite3_close(sql_var_handle);												// Datenbank schlieen

	return(0);
	}

