// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   shm_create.c   -   Anlegen der Shared-Memory-Bereiche                                                         **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2009 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <time.h>
#include <sys/time.h>
#include <unistd.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include "../sqlite/sqlite-3.7.3_arm/sqlite3.h"
#include "at91gpio.h"
#include "all_i2c.h"
#include "i2c_chips.h"
#include "sensor_demon.h"
#include "shm_use.h"



// *****   Hauptschleife   *****

int main(int argc,char **argv)
	{
	int shID;
	char *myPtr;
	int i;
	signed short int rw = 0;
	signed long int bts;


	bts = time(0);																				// Boot-Timestamp merken
	printf("shm_create V %s\n",SHM_VERSION);


	// DUMMY Shared Memory erzeugen
	// printf("shm_create: erzeuge DUMMY...\n");
	shID = shmget(SHM_ID_DUMMY,SHM_DUMMY_SIZE,IPC_CREAT | 0666);
	if (shID >= 0)
		{
		myPtr = shmat(shID,0,0);
		if (myPtr==(char *)-1)
			{
			printf("shm_create: SHMAT Fehler beim Zugreifen auf den Dummy-Speicher\n");
		goto errorende;
			}
		else
			{
			for (i = 0;i < SHM_DUMMY_SIZE;i++)								// mit Nullen fllen
				{
 				myPtr[i] = 0;
				}
			shmdt(myPtr);
			}
		}
	else
		{
		printf("chm_create: SHMGET Fehler beim Belegen des Dummy-Speichers\n");
		goto errorende;
		}



	// SENSORDATA Shared Memory erzeugen
	// printf("shm_create: erzeuge SENSORDATA...\n");
	shID = shmget(SHM_ID_SENSORDATA,SHM_SENSORDATA_SIZE,IPC_CREAT | 0666);
	if (shID < 0)
		{
		printf("shm_create: SHMGET Fehler beim Belegen des Sensordata-Speichers\n");
		goto errorende;
		}

	// SENSORCOUNT Shared Memory erzeugen
	// printf("shm_create: erzeuge SENSORCOUNT...\n");
	shID = shmget(SHM_ID_SENSORCOUNT,SHM_SENSORCOUNT_SIZE,IPC_CREAT | 0666);
	if (shID < 0)
		{
		printf("shm_create: SHMGET Fehler beim Belegen des Sensorcount-Speichers\n");
		goto errorende;
		}


	// ACTORDATA READ Shared Memory erzeugen
	// printf("shm_create: erzeuge ACTOR_R_DATA...\n");
	shID = shmget(SHM_ID_ACTOR_R_DATA,SHM_ACTOR_R_DATA_SIZE,IPC_CREAT | 0666);
	if (shID < 0)
		{
		printf("shm_create: SHMGET Fehler beim Belegen des Actor_r_data-Speichers\n");
		goto errorende;
		}

	// ACTORCOUNT READ Shared Memory erzeugen
	// printf("shm_create: erzeuge ACTOR_R_COUNT...\n");
	shID = shmget(SHM_ID_ACTOR_R_COUNT,SHM_ACTOR_R_COUNT_SIZE,IPC_CREAT | 0666);
	if (shID < 0)
		{
		printf("shm_create: SHMGET Fehler beim Belegen des Actor_r_count-Speichers\n");
		goto errorende;
		}


	// ACTORDATA WRITE Shared Memory erzeugen
	// printf("shm_create: erzeuge ACTOR_W_DATA...\n");
	shID = shmget(SHM_ID_ACTOR_W_DATA,SHM_ACTOR_W_DATA_SIZE,IPC_CREAT | 0666);
	if (shID < 0)
		{
		printf("shm_create: SHMGET Fehler beim Belegen des Actor_w_data-Speichers\n");
		goto errorende;
		}
	// ACTORCOUNT WRITE Shared Memory erzeugen
	// printf("shm_create: erzeuge ACTOR_W_COUNT...\n");
	shID = shmget(SHM_ID_ACTOR_W_COUNT,SHM_ACTOR_W_COUNT_SIZE,IPC_CREAT | 0666);
	if (shID < 0)
		{
		printf("shm_create: SHMGET Fehler beim Belegen des Actor_w_count-Speichers\n");
		goto errorende;
		}



	// DMX512 Shared Memory erzeugen
	// printf("shm_create: erzeuge DMX512...\n");
	shID = shmget(SHM_ID_DMX,SHM_DMX_SIZE,IPC_CREAT | 0666);
	if (shID >= 0)
		{
		myPtr = shmat(shID,0,0);
		if (myPtr==(char *)-1)
			{
			printf("shm_create: SHMAT Fehler beim Zugreifen auf den DMX-Speicher\n");
		goto errorende;
			}
		else
			{
			for (i = 0;i < SHM_DMX_SIZE;i++)								// mit Nullen fllen
				{
 				myPtr[i] = 0;
				}
			shmdt(myPtr);
			}
		}
	else
		{
		printf("shm_create: SHMGET Fehler beim Belegen des DMX-Speichers\n");
		goto errorende;
		}



	// Demonstatus Shared Memory erzeugen
	// printf("shm_create: erzeuge demonstatus...\n");
	shID = shmget(SHM_ID_DEMONSTATUS,SHM_DEMONSTATUS_SIZE,IPC_CREAT | 0666);
	if (shID >= 0)
		{
		myPtr = shmat(shID,0,0);
		if (myPtr==(char *)-1)
			{
			printf("shm_create: SHMAT Fehler beim Zugreifen auf den Demonstatus-Speicher\n");
		goto errorende;
			}
		else
			{
			for (i = 0;i < SHM_DEMONSTATUS_SIZE;i++)			// mit Nullen fllen
				{
 				myPtr[i] = 0;
				}
			shmdt(myPtr);
			}
		}
	else
		{
		printf("shm_create: SHMGET Fehler beim Belegen des Demonstatus-Speichers\n");
		goto errorende;
		}



	// ADC Shared Memory erzeugen
	// printf("shm_create: erzeuge ADC...\n");
	shID = shmget(SHM_ID_ADC,SHM_ADC_SIZE,IPC_CREAT | 0666);
	if (shID >= 0)
		{
		myPtr = shmat(shID,0,0);
		if (myPtr==(char *)-1)
			{
			printf("shm_create: SHMAT Fehler beim Zugreifen auf den ADC-Speicher\n");
		goto errorende;
			}
		else
			{
			for (i = 0;i < SHM_ADC_SIZE;i++)			// mit Nullen fllen
				{
 				myPtr[i] = 0;
				}
			shmdt(myPtr);
			}
		}
	else
		{
		printf("shm_create: SHMGET Fehler beim Belegen des ADC-Speichers\n");
		goto errorende;
		}





	// auf existierendes Shared Memory fr Demonstatus zugreifen

	if (use_my_demonstatus_shm(0) != 1) goto errorende;																	// 0: Creator

	// Status von Demon 0 (Creator) in SHM eintragen
	my_demonstatus_data[my_demon_id].demon_id = my_demon_id;														// 0 ist Default, hier wird die eigene ID eingetragen
	sprintf(my_demonstatus_data[my_demon_id].name_string,"shm_create");									// Name
	sprintf(my_demonstatus_data[my_demon_id].version_string,"%s",SHM_VERSION);					// Versionsnummer
	my_demonstatus_data[my_demon_id].last_boot = bts;																		// Timestamp(UTC) des Starts
	my_demonstatus_data[my_demon_id].last_activity = time(0);														// Timestamp(UTC) der letzten Aktion
	my_demonstatus_data[my_demon_id].ti = 0;																						// Counter
	sprintf(my_demonstatus_data[my_demon_id].debug_message,"finished");									// letzte Debug-Meldung
	my_demonstatus_data[my_demon_id].error_message[0] = 0;															// letzte Fehlermeldung
	my_demonstatus_data[my_demon_id].status_long = 0;																		// numerischer Status
	sprintf(my_demonstatus_data[my_demon_id].status_string,"SHM OK");										// String-Status
	rw = 0;
goto ende;

errorende:
	rw = -1;
ende:
	return(rw);
	}
