// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   sqldb.c   -   Funktionen fr Client                                                                           **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2009 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************



#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <time.h>
#include "../sqlite/sqlite-3.7.3_arm/sqlite3.h"
#include "sqldb.h"



// *****   Globale Variablen   *****

#define CONFIG_DATABASE_FILE "/etc/allnetenv/config.s3db"



// *****   sqldb_read_string()   -   String vom Server holen   *****

void sqldb_read_string(char string_name[],char *string_value)
	{
	sqlite3 *sql_config_handle;														// Handle fr die DB
	char sql[300];
	sqlite3_stmt *vm;
	char *sql_query;
	signed short int i = 0;
	// signed char zwischenspeicher[4096];
	signed short int rw;


beginn:
	sqlite3_open(CONFIG_DATABASE_FILE,&sql_config_handle);// SQLITE3-Datenbank ffnen
	sprintf(sql,"SELECT value FROM config WHERE tag='%s';",string_name);

	// printf("SQL:\"%s\"\n",sql);
	sql_query = sqlite3_mprintf("%s",sql);								// Vorbereitung des SQL-Querys
	
	// Umwandlung des SQl Querys in Byte-code
	rw = sqlite3_prepare(sql_config_handle,sql_query,strlen(sql_query),&vm,NULL);
	if (rw != SQLITE_OK)
		{
		// printf("(Error %d bei \"%s\")\n",rw,sql);
		// printf("SQLITE Read lock problem !!!!!\n");
		sqlite3_finalize(vm);																// Loeschen des Statements
		sqlite3_free(sql_query);														// freigeben des Bytecodes
		sqlite3_close(sql_config_handle);										// Datenbank schlieen
		usleep(25000);																			// 25 ms warten
		goto beginn;
		}

	// Ausgabe des Datensatzes
	while(sqlite3_step(vm) != SQLITE_DONE)
		{
		i++;
		if(sqlite3_column_text(vm,0) == NULL)
			{
			// printf("NULL Pointer als Result bei \"%s\"\n",sql);
			strcpy(string_value,"");
			goto final;
			}
		// printf("%s\n",sqlite3_column_text(vm,0));						// Inhalt des Datensatzes ausgeben
		strcpy(string_value,(char *)sqlite3_column_text(vm,0));			// String aus dem DB-Recordset kopieren
		}
	if(i < 1) strcpy(string_value,"");										// wenn kein Datensatz, leeren String zurckgeben

final:
	sqlite3_finalize(vm);																	// Loeschen des Statements
	sqlite3_free(sql_query);															// freigeben des Bytecodes
	sqlite3_close(sql_config_handle);											// Datenbank schlieen
	}



// *****   sqldb_read_long()   -   signed long vom Server holen   *****

signed long int sqldb_read_long(char string_name[])
	{
	char puffer[SQLDB_STRING_LENGTH];

	sqldb_read_string(string_name,puffer);
	// printf("sqldb_read_long(\"%s\") = \"%s\"\n",string_name,puffer);
	return(atol(puffer));
	}



// *****   sqldb_read_float()   -   double vom Server holen   *****

double sqldb_read_float(char string_name[])
	{
	char puffer[SQLDB_STRING_LENGTH];

	sqldb_read_string(string_name,puffer);
	return(atof(puffer));
	}



// *****   do_sqlyy   -   Ausfhren eines Querys   *****

void do_sqlyy(sqlite3 *ptr,char kommando[],unsigned char wait_for_write)
	{
	signed long int t;
	char *zErrMsg = 0;
	unsigned short int max_retries = 75;
	unsigned short int retries = 0;
	char kommando2[8192];


	if(wait_for_write > 0)
		{
		strcpy(kommando2,"PRAGMA count_changes = 0; ");
		strcat(kommando2,kommando);
		}
	else
		{
		strcpy(kommando2,"PRAGMA count_changes = 0; PRAGMA synchronous = 0; ");
		strcat(kommando2,kommando);
		}
again:
	t = sqlite3_exec(ptr,kommando2,NULL,NULL,&zErrMsg);

	if (t != SQLITE_OK)
		{
		if((t == SQLITE_BUSY) || (t == SQLITE_LOCKED))
			{
			usleep(66000);																		// 66 ms warten
			retries++;
			// printf("Retry %d...\n",retries);
			if(retries <= max_retries) goto again;						// wieder probieren
			// printf("Nach %d Versuchen: ",retries);						// max. 1 Sekunde
			}
    fprintf(stderr,"(SQL: \"%s\"\n",kommando);
    fprintf(stderr,"SQL error #%ld: %s (nach %d Versuchen)\n",t,zErrMsg,retries);
		sqlite3_free(zErrMsg);
		goto skip;
		}
	sqlite3_free(zErrMsg);
skip: ;
	}



// *****   sqldb_write_string()   -   String zum Server schicken   *****

void sqldb_write_string(char string_name[], char *string_value)
	{
	sqlite3 *sql_config_handle;														// Handle fr die DB
	char sql[2500];
	sqlite3_stmt *vm;
	char *sql_query;
	signed short int i = 0;

	sqlite3_open(CONFIG_DATABASE_FILE,&sql_config_handle);// SQLITE3-Datenbank ffnen

	// *** Versuchen, zu lesen ***
	sprintf(sql,"SELECT value FROM config WHERE tag='%s';",string_name);
	sql_query = sqlite3_mprintf("%s",sql);								// Vorbereitung des SQL-Querys
	// Umwandlung des SQl Querys in Byte-code
	sqlite3_prepare(sql_config_handle,sql_query,strlen(sql_query),&vm,NULL);

	while(sqlite3_step(vm) != SQLITE_DONE)
		{
		i++;																								// Fundstellen zhlen
		}
	sqlite3_finalize(vm);																	// Loeschen des Statements
	sqlite3_free(sql_query);															// freigeben des Bytecodes

	if(i < 1) 
		{
		// nicht gefunden, es muss ein INSERT durchgefhrt werden
		// printf("nicht gefunden\n");																// wenn kein Datensatz, leere Zeile ausgeben
		sprintf(sql,"INSERT INTO config (tag,value) values ('%s','%s');",string_name,string_value);
		}
	else
		{
		// gefunden, ein UPDATE reicht
		// printf("gefunden !\n");
		sprintf(sql,"UPDATE config SET value='%s' where tag='%s';",string_value,string_name);
		}
	do_sqlyy(sql_config_handle,sql,1);										// Befehl ausfhren
	sqlite3_close(sql_config_handle);											// Datenbank schlieen
	}



// *****   sqldb_write_long()   -   signed long zum Server schicken   *****

void sqldb_write_long(char string_name[],signed long int wert)
	{
	char puffer[SQLDB_STRING_LENGTH];

	memset(puffer,0,SQLDB_STRING_LENGTH);
	sprintf(puffer,"%ld",wert);
	sqldb_write_string(string_name,puffer);
	}



// *****   sqldb_write_long()   -   double zum Server schicken   *****

void sqldb_write_float(char string_name[],double wert)
	{
	char puffer[SQLDB_STRING_LENGTH];

	memset(puffer,0,SQLDB_STRING_LENGTH);
	sprintf(puffer,"%4.2f",wert);
	sqldb_write_string(string_name,puffer);
	}








// *****   sqldb_read_string2()   -   String vom Server holen   *****

void sqldb_read_string2(sqlite3 *sql_config_handle,char string_name[],char *string_value)
	{
	char sql[300];
	sqlite3_stmt *vm;
	char *sql_query;
	signed short int i = 0;
	signed short int rw;


beginn:
	sprintf(sql,"SELECT value FROM config WHERE tag='%s';",string_name);

	// printf("SQL:\"%s\"\n",sql);
	sql_query = sqlite3_mprintf("%s",sql);								// Vorbereitung des SQL-Querys
	
	// Umwandlung des SQl Querys in Byte-code
	rw = sqlite3_prepare(sql_config_handle,sql_query,strlen(sql_query),&vm,NULL);
	if (rw != SQLITE_OK)
		{
		// printf("(Error %d bei \"%s\")\n",rw,sql);
		// printf("SQLITE Read lock problem !!!!!\n");
		sqlite3_finalize(vm);																// Loeschen des Statements
		sqlite3_free(sql_query);														// freigeben des Bytecodes
		sqlite3_close(sql_config_handle);										// Datenbank schlieen
		usleep(25000);																			// 25 ms warten
		goto beginn;
		}

	// Ausgabe des Datensatzes
	while(sqlite3_step(vm) != SQLITE_DONE)
		{
		i++;
		if(sqlite3_column_text(vm,0) == NULL)
			{
			// printf("NULL Pointer als Result bei \"%s\"\n",sql);
			strcpy(string_value,"");
			goto final;
			}
		// printf("%s\n",sqlite3_column_text(vm,0));						// Inhalt des Datensatzes ausgeben
		strcpy(string_value,(char *)sqlite3_column_text(vm,0));			// String aus dem DB-Recordset kopieren
		}
	if(i < 1) strcpy(string_value,"");										// wenn kein Datensatz, leeren String zurckgeben

final:
	sqlite3_finalize(vm);																	// Loeschen des Statements
	sqlite3_free(sql_query);															// freigeben des Bytecodes
	}



// *****   sqldb_read_long2()   -   signed long vom Server holen   *****

signed long int sqldb_read_long2(sqlite3 *sql_config_handle,char string_name[])
	{
	char puffer[SQLDB_STRING_LENGTH];

	sqldb_read_string2(sql_config_handle,string_name,puffer);
	return(atol(puffer));
	}



// *****   sqldb_read_float2()   -   double vom Server holen   *****

double sqldb_read_float2(sqlite3 *sql_config_handle,char string_name[])
	{
	char puffer[SQLDB_STRING_LENGTH];

	sqldb_read_string2(sql_config_handle,string_name,puffer);
	return(atof(puffer));
	}


// *****   sqldb_write_string2()   -   String zum Server schicken   *****

void sqldb_write_string2(sqlite3 *sql_config_handle,char string_name[], char *string_value)
	{
	char sql[2500];
	sqlite3_stmt *vm;
	char *sql_query;
	signed short int i = 0;


	// *** Versuchen, zu lesen ***
	sprintf(sql,"SELECT value FROM config WHERE tag='%s';",string_name);
	sql_query = sqlite3_mprintf("%s",sql);								// Vorbereitung des SQL-Querys
	// Umwandlung des SQl Querys in Byte-code
	sqlite3_prepare(sql_config_handle,sql_query,strlen(sql_query),&vm,NULL);

	while(sqlite3_step(vm) != SQLITE_DONE)
		{
		i++;																								// Fundstellen zhlen
		}
	sqlite3_finalize(vm);																	// Loeschen des Statements
	sqlite3_free(sql_query);															// freigeben des Bytecodes

	if(i < 1) 
		{
		// nicht gefunden, es muss ein INSERT durchgefhrt werden
		// printf("nicht gefunden\n");																// wenn kein Datensatz, leere Zeile ausgeben
		sprintf(sql,"INSERT INTO config (tag,value) values ('%s','%s');",string_name,string_value);
		}
	else
		{
		// gefunden, ein UPDATE reicht
		// printf("gefunden !\n");
		sprintf(sql,"UPDATE config SET value='%s' where tag='%s';",string_value,string_name);
		}
	do_sqlyy(sql_config_handle,sql,1);										// Befehl ausfhren
	}



// *****   sqldb_write_long2()   -   signed long zum Server schicken   *****

void sqldb_write_long2(sqlite3 *sql_config_handle,char string_name[],signed long int wert)
	{
	char puffer[SQLDB_STRING_LENGTH];

	memset(puffer,0,SQLDB_STRING_LENGTH);
	sprintf(puffer,"%ld",wert);
	sqldb_write_string2(sql_config_handle,string_name,puffer);
	}



// *****   sqldb_write_float2()   -   double zum Server schicken   *****

void sqldb_write_float2(sqlite3 *sql_config_handle,char string_name[],double wert)
	{
	char puffer[SQLDB_STRING_LENGTH];

	memset(puffer,0,SQLDB_STRING_LENGTH);
	sprintf(puffer,"%4.2f",wert);
	sqldb_write_string2(sql_config_handle,string_name,puffer);
	}






// *****   sqldb_read_string3()   -   String mit eigenem Query vom Server holen   *****

void sqldb_read_string3(sqlite3 *sql_config_handle,char sql[],char *string_value)
	{
	// char sql[300];
	sqlite3_stmt *vm;
	char *sql_query;
	signed short int i = 0;
	signed short int rw;


beginn:
	// printf("SQL:\"%s\"\n",sql);
	sql_query = sqlite3_mprintf("%s",sql);								// Vorbereitung des SQL-Querys
	
	// Umwandlung des SQl Querys in Byte-code
	rw = sqlite3_prepare(sql_config_handle,sql_query,strlen(sql_query),&vm,NULL);
	if (rw != SQLITE_OK)
		{
		// printf("(Error %d bei \"%s\")\n",rw,sql);
		// printf("SQLITE Read lock problem !!!!!\n");
		sqlite3_finalize(vm);																// Loeschen des Statements
		sqlite3_free(sql_query);														// freigeben des Bytecodes
		sqlite3_close(sql_config_handle);										// Datenbank schlieen
		usleep(25000);																			// 25 ms warten
		goto beginn;
		}

	// Ausgabe des Datensatzes
	while(sqlite3_step(vm) != SQLITE_DONE)
		{
		i++;
		if(sqlite3_column_text(vm,0) == NULL)
			{
			// printf("NULL Pointer als Result bei \"%s\"\n",sql);
			strcpy(string_value,"");
			goto final;
			}
		// printf("%s\n",sqlite3_column_text(vm,0));						// Inhalt des Datensatzes ausgeben
		strcpy(string_value,(char *)sqlite3_column_text(vm,0));			// String aus dem DB-Recordset kopieren
		}
	if(i < 1) strcpy(string_value,"");										// wenn kein Datensatz, leeren String zurckgeben

final:
	sqlite3_finalize(vm);																	// Loeschen des Statements
	sqlite3_free(sql_query);															// freigeben des Bytecodes
	}
