// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   udp_all3075.c   -   Commandlinetool zum Steuern von ALL3075-Steckdosen via UDP                                **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2011 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <fcntl.h>


// *****   udp_send() - Daten senden   *****

void udp_send(char zielip[],unsigned short int portnummer,unsigned char *daten,unsigned short int laenge)
	{
	int							udp_socket;
	struct					sockaddr_in steuerstruct;

	// printf("udp_send an %s (Port:%d, Byte0:%d, Byte1:%d)\n",zielip,portnummer,daten[0],daten[1]);

	if ((udp_socket = socket(PF_INET,SOCK_DGRAM,IPPROTO_UDP)) >= 0) // UDP-Socket anlegen
		{
		memset(&steuerstruct,0,sizeof(steuerstruct));				// Struct auf 0 setzen
		steuerstruct.sin_family = AF_INET;									// Internet/IP
		steuerstruct.sin_addr.s_addr = inet_addr(zielip);		// IP-Addresse
		steuerstruct.sin_port = htons(portnummer);					// UDP-Portnummer

		sendto(udp_socket,daten,laenge,0,(struct sockaddr *) &steuerstruct,sizeof(steuerstruct));
		close(udp_socket);
		// printf("OK.\n");
		}
	}



void print_usage()
	{
	printf("USAGE: udp_all3075 target udp_port byte0 byte1\n");
	exit(0);
	}



// *****   Testprogramm   *****

int main(int argc,char **argv)
	{
	unsigned char						puffer[3];										// Sendepuffer fr das UDP-Paket
	char										udp_target[256];							// IP-Adresse des Targets
	unsigned short int			udp_port = 54321;							// TCP Socket fr Client/Server Verbindung
	unsigned char						udp_byte0;										// Byte 0
	unsigned char						udp_byte1;										// Byte 1


 	if (argc != 5)
		{
		print_usage();
		goto ende;
		}


	strcpy(udp_target,argv[1]);
	udp_port = atoi(argv[2]);
 	udp_byte0 = (unsigned char)atoi(argv[3]);
 	udp_byte1 = (unsigned char)atoi(argv[4]);

	// printf("udp_all3075 (%d:%d), %s:%d\n",udp_byte0,udp_byte1,udp_target,udp_port);

	puffer[0] = udp_byte0;
	puffer[1] = udp_byte1;
	puffer[2] = 0;

	udp_send(udp_target,udp_port,puffer,2);

ende: return(0);
	}

