// *********************************************************************************************************************
// *********************************************************************************************************************
// **                                                                                                                 **
// **   xml_edit.c   -   Tags aus XML-Dateien auslesen und diese auch hineinschreiben                                 **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** (C) 2009 - 2011 by Allnet Deutschland GmbH (www.allnet.de)                                                      **
// **                    Michael Buchstaller     (buchi@allnet.de)                                                    **
// **                                                                                                                 **
// **-----------------------------------------------------------------------------------------------------------------**
// **                                                                                                                 **
// ** This program is free software: you can redistribute it and/or modify                                            **
// ** it under the terms of the GNU General Public License as published by                                            **
// ** the Free Software Foundation, either version 3 of the License, or                                               **
// ** (at your option) any later version.                                                                             **
// **                                                                                                                 **
// ** This program is distributed in the hope that it will be useful,                                                 **
// ** but WITHOUT ANY WARRANTY; without even the implied warranty of                                                  **
// ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                                   **
// ** GNU General Public License for more details.                                                                    **
// **                                                                                                                 **
// ** You should have received a copy of the GNU General Public License                                               **
// ** along with this program.  If not, see http://www.gnu.org/licenses                                               **
// **                                                                                                                 **
// *********************************************************************************************************************
// *********************************************************************************************************************


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>
#include "xml_lib.h"



// *****   main()   -   Hauptprogramm   *****

int main (int argc,char **argv)
	{
	char xml_filename[250];																// cmdline-Parameter Name der XML-Datei
	char xml_tagname[80];																	// cmdline-Parameter Name des Tags
	char xml_taginhalt[250];															// cmdline-Parameter Inhalt der Variablen
	unsigned char xml_write = 1;													// Cmdline-Parameter Read(0) oder Write(1)
	signed long int rw = 0;																// Rckwert


	if (argc == 4)
		{
		xml_write = atoi(argv[3]);
		if (xml_write != 0)
			{
			printf("ERROR: usage: xml_edit \"xml_filename\" \"xml_section.xml_tagname\" xml_read(0)write(1) (\"xml_filename\")\n");
			printf("3 parameters given (no data to write), but r/w-flag is %d instead of 0.\n",xml_write);
			goto ende;
			}
		}

	if ((argc != 5) && (xml_write != 0))
		{
		printf("ERROR: usage: xml_edit \"xml_filename\" \"xml_section.xml_tagname\" xml_read(0)write(1) (\"xml_filename\")\n");
		goto ende;
		}

		strcpy(xml_filename,argv[1]);
		strcpy(xml_tagname,argv[2]);
		xml_write = atoi(argv[3]);
		if (argc == 5) strcpy(xml_taginhalt,argv[4]);


	if (xml_write != 0) goto schreiben;




	// ***** Lesen *****
	rw = read_xml(xml_filename,xml_tagname,xml_taginhalt);
	if (rw >= 0)
		{
		printf("%s\n",xml_taginhalt);
		}
	else
		{
		printf("ERROR %ld\n",rw);
		}
	goto ende;


	// ***** Schreiben *****
schreiben:
	rw = write_xml(xml_filename,xml_tagname,xml_taginhalt);
	if (rw >= 0)
		{
		printf("%s\n",xml_taginhalt);
		}
	else
		{
		printf("ERROR %ld\n",rw);
		}
	goto ende;


ende:
	return(rw);
	}
